// D import file generated from 'derelict/sfml2/audio.d'
module derelict.sfml2.audio;
public import derelict.util.loader;

private 
{
	import derelict.util.exception;
	import derelict.util.system;
	import derelict.sfml2.system;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "csfml-audio.dll,csfml-audio-2.dll,csmfl-audio-2.3.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libcsfml-audio.dylib,libcsfml-audio.2.dylib,libcsfml-audio.2.3.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libcsfml-audio.so,libcsfml-audio.so.2,libcsfml-audio.so.2.3";
			}
			else
			{
				static assert(0, "Need to implement SFML2 Audio libNames for this operating system.");
			}
		}
	}
}
struct sfMusic;
struct sfSound;
struct sfSoundBuffer;
struct sfSoundBufferRecorder;
struct sfSoundRecorder;
struct sfSoundStream;
extern (C) nothrow 
{
	alias sfBool function(void*) sfSoundRecorderStartCallback;
	alias sfBool function(const(sfInt16)*, size_t, void*) sfSoundRecorderProcessCallback;
	alias void function(void*) sfSoundRecorderStopCallback;
}

alias int sfSoundStatus;
enum 
{
	sfStopped,
	sfPaused,
	sfPlaying,
}
struct sfSoundStreamChunk
{
	sfInt16* samples;
	uint sampleCount;
}
extern (C) nothrow 
{
	alias sfBool function(sfSoundStreamChunk*, void*) sfSoundStreamGetDataCallback;
	alias void function(sfTime, void*) sfSoundStreamSeekCallback;
}

extern (C) nothrow @nogc 
{
	alias void function(float) da_sfListener_setGlobalVolume;
	alias float function() da_sfListener_getGlobalVolume;
	alias void function(sfVector3f) da_sfListener_setPosition;
	alias sfVector3f function() da_sfListener_getPosition;
	alias void function(sfVector3f) da_sfListener_setDirection;
	alias sfVector3f function() da_sfListener_getDirection;
	alias void function(sfVector3f) da_sfListener_setUpVector;
	alias sfVector3f function() da_sfListener_getUpVector;
	alias sfMusic* function(const(char)*) da_sfMusic_createFromFile;
	alias sfMusic* function(const(void)*, size_t) da_sfMusic_createFromMemory;
	alias sfMusic* function(sfInputStream*) da_sfMusic_createFromStream;
	alias void function(sfMusic*) da_sfMusic_destroy;
	alias void function(sfMusic*, sfBool) da_sfMusic_setLoop;
	alias sfBool function(const(sfMusic)*) da_sfMusic_getLoop;
	alias sfTime function(const(sfMusic)*) da_sfMusic_getDuration;
	alias void function(sfMusic*) da_sfMusic_play;
	alias void function(sfMusic*) da_sfMusic_pause;
	alias void function(sfMusic*) da_sfMusic_stop;
	alias uint function(const(sfMusic)*) da_sfMusic_getChannelCount;
	alias uint function(const(sfMusic)*) da_sfMusic_getSampleRate;
	alias sfSoundStatus function(const(sfMusic)*) da_sfMusic_getStatus;
	alias sfTime function(const(sfMusic)*) da_sfMusic_getPlayingOffset;
	alias void function(sfMusic*, float) da_sfMusic_setPitch;
	alias void function(sfMusic*, float) da_sfMusic_setVolume;
	alias void function(sfMusic*, sfVector3f) da_sfMusic_setPosition;
	alias void function(sfMusic*, sfBool) da_sfMusic_setRelativeToListener;
	alias void function(sfMusic*, float) da_sfMusic_setMinDistance;
	alias void function(sfMusic*, float) da_sfMusic_setAttenuation;
	alias void function(sfMusic*, sfTime) da_sfMusic_setPlayingOffset;
	alias float function(const(sfMusic)*) da_sfMusic_getPitch;
	alias float function(const(sfMusic)*) da_sfMusic_getVolume;
	alias sfVector3f function(const(sfMusic)*) da_sfMusic_getPosition;
	alias sfBool function(const(sfMusic)*) da_sfMusic_isRelativeToListener;
	alias float function(const(sfMusic)*) da_sfMusic_getMinDistance;
	alias float function(const(sfMusic)*) da_sfMusic_getAttenuation;
	alias sfSound* function() da_sfSound_create;
	alias sfSound* function(const(sfSound)*) da_sfSound_copy;
	alias void function(sfSound*) da_sfSound_destroy;
	alias void function(sfSound*) da_sfSound_play;
	alias void function(sfSound*) da_sfSound_pause;
	alias void function(sfSound*) da_sfSound_stop;
	alias void function(sfSound*, const(sfSoundBuffer)*) da_sfSound_setBuffer;
	alias const(sfSoundBuffer)* function(const(sfSound)*) da_sfSound_getBuffer;
	alias void function(sfSound*, sfBool) da_sfSound_setLoop;
	alias sfBool function(const(sfSound)*) da_sfSound_getLoop;
	alias sfSoundStatus function(const(sfSound)*) da_sfSound_getStatus;
	alias void function(sfSound*, float) da_sfSound_setPitch;
	alias void function(sfSound*, float) da_sfSound_setVolume;
	alias void function(sfSound*, sfVector3f) da_sfSound_setPosition;
	alias void function(sfSound*, sfBool) da_sfSound_setRelativeToListener;
	alias void function(sfSound*, float) da_sfSound_setMinDistance;
	alias void function(sfSound*, float) da_sfSound_setAttenuation;
	alias void function(sfSound*, sfTime) da_sfSound_setPlayingOffset;
	alias float function(const(sfSound)*) da_sfSound_getPitch;
	alias float function(const(sfSound)*) da_sfSound_getVolume;
	alias sfVector3f function(const(sfSound)*) da_sfSound_getPosition;
	alias sfBool function(const(sfSound)*) da_sfSound_isRelativeToListener;
	alias float function(const(sfSound)*) da_sfSound_getMinDistance;
	alias float function(const(sfSound)*) da_sfSound_getAttenuation;
	alias sfTime function(const(sfSound)*) da_sfSound_getPlayingOffset;
	alias sfSoundBuffer* function(const(char)*) da_sfSoundBuffer_createFromFile;
	alias sfSoundBuffer* function(const(void)*, size_t) da_sfSoundBuffer_createFromMemory;
	alias sfSoundBuffer* function(sfInputStream*) da_sfSoundBuffer_createFromStream;
	alias sfSoundBuffer* function(const(sfInt16)*, sfUint64, uint, uint) da_sfSoundBuffer_createFromSamples;
	alias sfSoundBuffer* function(const(sfSoundBuffer)*) da_sfSoundBuffer_copy;
	alias void function(sfSoundBuffer*) da_sfSoundBuffer_destroy;
	alias sfBool function(const(sfSoundBuffer)*, const(char)*) da_sfSoundBuffer_saveToFile;
	alias const(sfInt16)* function(const(sfSoundBuffer)*) da_sfSoundBuffer_getSamples;
	alias sfUint64 function(const(sfSoundBuffer)*) da_sfSoundBuffer_getSampleCount;
	alias uint function(const(sfSoundBuffer)*) da_sfSoundBuffer_getSampleRate;
	alias uint function(const(sfSoundBuffer)*) da_sfSoundBuffer_getChannelCount;
	alias sfTime function(const(sfSoundBuffer)*) da_sfSoundBuffer_getDuration;
	alias sfSoundBufferRecorder* function() da_sfSoundBufferRecorder_create;
	alias void function(sfSoundBufferRecorder*) da_sfSoundBufferRecorder_destroy;
	alias void function(sfSoundBufferRecorder*, uint) da_sfSoundBufferRecorder_start;
	alias void function(sfSoundBufferRecorder*) da_sfSoundBufferRecorder_stop;
	alias uint function(const(sfSoundBufferRecorder)*) da_sfSoundBufferRecorder_getSampleRate;
	alias const(sfSoundBuffer)* function(const(sfSoundBufferRecorder)*) da_sfSoundBufferRecorder_getBuffer;
	alias sfSoundRecorder* function(sfSoundRecorderStartCallback, sfSoundRecorderProcessCallback, sfSoundRecorderStopCallback, void*) da_sfSoundRecorder_create;
	alias void function(sfSoundRecorder*) da_sfSoundRecorder_destroy;
	alias sfBool function(sfSoundRecorder*, uint) da_sfSoundRecorder_start;
	alias void function(sfSoundRecorder*) da_sfSoundRecorder_stop;
	alias uint function(const(sfSoundRecorder)*) da_sfSoundRecorder_getSampleRate;
	alias sfBool function() da_sfSoundRecorder_isAvailable;
	alias void function(sfSoundRecorder*, sfTime) da_sfSoundRecorder_setProcessingInterval;
	alias const(char)** function(size_t*) da_sfSoundRecorder_getAvailableDevices;
	alias const(char)* function() da_sfSoundRecorder_getDefaultDevice;
	alias sfBool function(sfSoundRecorder*, const(char)*) da_sfSoundRecorder_setDevice;
	alias const(char)* function(sfSoundRecorder*) da_sfSoundRecorder_getDevice;
	alias sfSoundStream* function(sfSoundStreamGetDataCallback, sfSoundStreamSeekCallback, uint, int, void*) da_sfSoundStream_create;
	alias void function(sfSoundStream*) da_sfSoundStream_destroy;
	alias void function(sfSoundStream*) da_sfSoundStream_play;
	alias void function(sfSoundStream*) da_sfSoundStream_pause;
	alias void function(sfSoundStream*) da_sfSoundStream_stop;
	alias sfSoundStatus function(const(sfSoundStream)*) da_sfSoundStream_getStatus;
	alias uint function(const(sfSoundStream)*) da_sfSoundStream_getChannelCount;
	alias uint function(const(sfSoundStream)*) da_sfSoundStream_getSampleRate;
	alias void function(sfSoundStream*, float) da_sfSoundStream_setPitch;
	alias void function(sfSoundStream*, float) da_sfSoundStream_setVolume;
	alias void function(sfSoundStream*, sfVector3f) da_sfSoundStream_setPosition;
	alias void function(sfSoundStream*, sfBool) da_sfSoundStream_setRelativeToListener;
	alias void function(sfSoundStream*, float) da_sfSoundStream_setMinDistance;
	alias void function(sfSoundStream*, float) da_sfSoundStream_setAttenuation;
	alias void function(sfSoundStream*, sfTime) da_sfSoundStream_setPlayingOffset;
	alias void function(sfSoundStream*, sfBool) da_sfSoundStream_setLoop;
	alias float function(const(sfSoundStream)*) da_sfSoundStream_getPitch;
	alias float function(const(sfSoundStream)*) da_sfSoundStream_getVolume;
	alias sfVector3f function(const(sfSoundStream)*) da_sfSoundStream_getPosition;
	alias sfBool function(const(sfSoundStream)*) da_sfSoundStream_isRelativeToListener;
	alias float function(const(sfSoundStream)*) da_sfSoundStream_getMinDistance;
	alias float function(const(sfSoundStream)*) da_sfSoundStream_getAttenuation;
	alias sfBool function(const(sfSoundStream)*) da_sfSoundStream_getLoop;
	alias sfTime function(const(sfSoundStream)*) da_sfSoundStream_getPlayingOffset;
}

__gshared 
{
	da_sfListener_setGlobalVolume sfListener_setGlobalVolume;
	da_sfListener_getGlobalVolume sfListener_getGlobalVolume;
	da_sfListener_setPosition sfListener_setPosition;
	da_sfListener_getPosition sfListener_getPosition;
	da_sfListener_setDirection sfListener_setDirection;
	da_sfListener_getDirection sfListener_getDirection;
	da_sfListener_setUpVector sfListener_setUpVector;
	da_sfListener_getUpVector sfListener_getUpVector;
	da_sfMusic_createFromFile sfMusic_createFromFile;
	da_sfMusic_createFromMemory sfMusic_createFromMemory;
	da_sfMusic_createFromStream sfMusic_createFromStream;
	da_sfMusic_destroy sfMusic_destroy;
	da_sfMusic_setLoop sfMusic_setLoop;
	da_sfMusic_getLoop sfMusic_getLoop;
	da_sfMusic_getDuration sfMusic_getDuration;
	da_sfMusic_play sfMusic_play;
	da_sfMusic_pause sfMusic_pause;
	da_sfMusic_stop sfMusic_stop;
	da_sfMusic_getChannelCount sfMusic_getChannelCount;
	da_sfMusic_getSampleRate sfMusic_getSampleRate;
	da_sfMusic_getStatus sfMusic_getStatus;
	da_sfMusic_getPlayingOffset sfMusic_getPlayingOffset;
	da_sfMusic_setPitch sfMusic_setPitch;
	da_sfMusic_setVolume sfMusic_setVolume;
	da_sfMusic_setPosition sfMusic_setPosition;
	da_sfMusic_setRelativeToListener sfMusic_setRelativeToListener;
	da_sfMusic_setMinDistance sfMusic_setMinDistance;
	da_sfMusic_setAttenuation sfMusic_setAttenuation;
	da_sfMusic_setPlayingOffset sfMusic_setPlayingOffset;
	da_sfMusic_getPitch sfMusic_getPitch;
	da_sfMusic_getVolume sfMusic_getVolume;
	da_sfMusic_getPosition sfMusic_getPosition;
	da_sfMusic_isRelativeToListener sfMusic_isRelativeToListener;
	da_sfMusic_getMinDistance sfMusic_getMinDistance;
	da_sfMusic_getAttenuation sfMusic_getAttenuation;
	da_sfSound_create sfSound_create;
	da_sfSound_copy sfSound_copy;
	da_sfSound_destroy sfSound_destroy;
	da_sfSound_play sfSound_play;
	da_sfSound_pause sfSound_pause;
	da_sfSound_stop sfSound_stop;
	da_sfSound_setBuffer sfSound_setBuffer;
	da_sfSound_getBuffer sfSound_getBuffer;
	da_sfSound_setLoop sfSound_setLoop;
	da_sfSound_getLoop sfSound_getLoop;
	da_sfSound_getStatus sfSound_getStatus;
	da_sfSound_setPitch sfSound_setPitch;
	da_sfSound_setVolume sfSound_setVolume;
	da_sfSound_setPosition sfSound_setPosition;
	da_sfSound_setRelativeToListener sfSound_setRelativeToListener;
	da_sfSound_setMinDistance sfSound_setMinDistance;
	da_sfSound_setAttenuation sfSound_setAttenuation;
	da_sfSound_setPlayingOffset sfSound_setPlayingOffset;
	da_sfSound_getPitch sfSound_getPitch;
	da_sfSound_getVolume sfSound_getVolume;
	da_sfSound_getPosition sfSound_getPosition;
	da_sfSound_isRelativeToListener sfSound_isRelativeToListener;
	da_sfSound_getMinDistance sfSound_getMinDistance;
	da_sfSound_getAttenuation sfSound_getAttenuation;
	da_sfSound_getPlayingOffset sfSound_getPlayingOffset;
	da_sfSoundBuffer_createFromFile sfSoundBuffer_createFromFile;
	da_sfSoundBuffer_createFromMemory sfSoundBuffer_createFromMemory;
	da_sfSoundBuffer_createFromStream sfSoundBuffer_createFromStream;
	da_sfSoundBuffer_createFromSamples sfSoundBuffer_createFromSamples;
	da_sfSoundBuffer_copy sfSoundBuffer_copy;
	da_sfSoundBuffer_destroy sfSoundBuffer_destroy;
	da_sfSoundBuffer_saveToFile sfSoundBuffer_saveToFile;
	da_sfSoundBuffer_getSamples sfSoundBuffer_getSamples;
	da_sfSoundBuffer_getSampleCount sfSoundBuffer_getSampleCount;
	da_sfSoundBuffer_getSampleRate sfSoundBuffer_getSampleRate;
	da_sfSoundBuffer_getChannelCount sfSoundBuffer_getChannelCount;
	da_sfSoundBuffer_getDuration sfSoundBuffer_getDuration;
	da_sfSoundBufferRecorder_create sfSoundBufferRecorder_create;
	da_sfSoundBufferRecorder_destroy sfSoundBufferRecorder_destroy;
	da_sfSoundBufferRecorder_start sfSoundBufferRecorder_start;
	da_sfSoundBufferRecorder_stop sfSoundBufferRecorder_stop;
	da_sfSoundBufferRecorder_getSampleRate sfSoundBufferRecorder_getSampleRate;
	da_sfSoundBufferRecorder_getBuffer sfSoundBufferRecorder_getBuffer;
	da_sfSoundRecorder_create sfSoundRecorder_create;
	da_sfSoundRecorder_destroy sfSoundRecorder_destroy;
	da_sfSoundRecorder_start sfSoundRecorder_start;
	da_sfSoundRecorder_stop sfSoundRecorder_stop;
	da_sfSoundRecorder_getSampleRate sfSoundRecorder_getSampleRate;
	da_sfSoundRecorder_isAvailable sfSoundRecorder_isAvailable;
	da_sfSoundRecorder_setProcessingInterval sfSoundRecorder_setProcessingInterval;
	da_sfSoundRecorder_getAvailableDevices sfSoundRecorder_getAvailableDevices;
	da_sfSoundRecorder_getDefaultDevice sfSoundRecorder_getDefaultDevice;
	da_sfSoundRecorder_setDevice sfSoundRecorder_setDevice;
	da_sfSoundRecorder_getDevice sfSoundRecorder_getDevice;
	da_sfSoundStream_create sfSoundStream_create;
	da_sfSoundStream_destroy sfSoundStream_destroy;
	da_sfSoundStream_play sfSoundStream_play;
	da_sfSoundStream_pause sfSoundStream_pause;
	da_sfSoundStream_stop sfSoundStream_stop;
	da_sfSoundStream_getStatus sfSoundStream_getStatus;
	da_sfSoundStream_getChannelCount sfSoundStream_getChannelCount;
	da_sfSoundStream_getSampleRate sfSoundStream_getSampleRate;
	da_sfSoundStream_setPitch sfSoundStream_setPitch;
	da_sfSoundStream_setVolume sfSoundStream_setVolume;
	da_sfSoundStream_setPosition sfSoundStream_setPosition;
	da_sfSoundStream_setRelativeToListener sfSoundStream_setRelativeToListener;
	da_sfSoundStream_setMinDistance sfSoundStream_setMinDistance;
	da_sfSoundStream_setAttenuation sfSoundStream_setAttenuation;
	da_sfSoundStream_setPlayingOffset sfSoundStream_setPlayingOffset;
	da_sfSoundStream_setLoop sfSoundStream_setLoop;
	da_sfSoundStream_getPitch sfSoundStream_getPitch;
	da_sfSoundStream_getVolume sfSoundStream_getVolume;
	da_sfSoundStream_getPosition sfSoundStream_getPosition;
	da_sfSoundStream_isRelativeToListener sfSoundStream_isRelativeToListener;
	da_sfSoundStream_getMinDistance sfSoundStream_getMinDistance;
	da_sfSoundStream_getAttenuation sfSoundStream_getAttenuation;
	da_sfSoundStream_getLoop sfSoundStream_getLoop;
	da_sfSoundStream_getPlayingOffset sfSoundStream_getPlayingOffset;
}
class DerelictSFML2AudioLoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();

}
__gshared DerelictSFML2AudioLoader DerelictSFML2Audio;

shared static this();
