// D import file generated from 'derelict/sfml2/graphics.d'
module derelict.sfml2.graphics;
public import derelict.util.loader;

private 
{
	import derelict.util.exception;
	import derelict.util.system;
	import derelict.sfml2.system;
	import derelict.sfml2.window;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "csfml-graphics.dll,csfml-graphics-2.dll,csfml-graphics-2.3.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libcsfml-graphics.dylib,libcsfml-graphics.2.dylib,libcsfml-graphics.2.3.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libcsfml-graphics.so,libcsfml-graphics.so.2,libcsfml-graphics.so.2.3";
			}
			else
			{
				static assert(0, "Need to implement SFML2 Graphics libNames for this operating system.");
			}
		}
	}
}
struct sfCircleShape;
struct sfConvexShape;
struct sfFont;
struct sfImage;
struct sfShader;
struct sfRectangleShape;
struct sfRenderTexture;
struct sfRenderWindow;
struct sfShape;
struct sfSprite;
struct sfText;
struct sfTexture;
struct sfTransformable;
struct sfVertexArray;
struct sfView;
alias int sfBlendFactor;
enum 
{
	sfBlendFactorZero,
	sfBlendFactorOne,
	sfBlendFactorSrcColor,
	sfBlendFactorOneMinusSrcColor,
	sfBlendFactorDstColor,
	sfBlendFactorOneMinusDstColor,
	sfBlendFactorSrcAlpha,
	sfBlendFactorOneMinusSrcAlpha,
	sfBlendFactorDstAlpha,
	sfBlendFactorOneMinusDstAlpha,
}
alias int sfBlendEquation;
enum 
{
	sfBlendEquationAdd,
	sfBlendEquationSubtract,
}
struct sfBlendMode
{
	sfBlendFactor colorSrcFactor;
	sfBlendFactor colorDstFactor;
	sfBlendEquation colorEquation;
	sfBlendFactor alphaSrcFactor;
	sfBlendFactor alphaDstFactor;
	sfBlendEquation alphaEquation;
}
__gshared 
{
	immutable(sfBlendMode) sfBlendAlpha = sfBlendMode(sfBlendFactorSrcAlpha, sfBlendFactorOneMinusSrcAlpha, sfBlendEquationAdd, sfBlendFactorOne, sfBlendFactorOneMinusSrcAlpha, sfBlendEquationAdd);
	immutable(sfBlendMode) sfBlendAdd = sfBlendMode(sfBlendFactorSrcAlpha, sfBlendFactorOne, sfBlendEquationAdd, sfBlendFactorOne, sfBlendFactorOne, sfBlendEquationAdd);
	immutable(sfBlendMode) sfBlendMultiply = sfBlendMode(sfBlendFactorDstColor, sfBlendFactorZero, sfBlendEquationAdd, sfBlendFactorDstColor, sfBlendFactorZero, sfBlendEquationAdd);
	immutable(sfBlendMode) sfBlendNone = sfBlendMode(sfBlendFactorOne, sfBlendFactorZero, sfBlendEquationAdd, sfBlendFactorOne, sfBlendFactorZero, sfBlendEquationAdd);
}
struct sfColor
{
	sfUint8 r;
	sfUint8 g;
	sfUint8 b;
	sfUint8 a;
}
__gshared 
{
	immutable(sfColor) sfBlack = sfColor(0, 0, 0, 255);
	immutable(sfColor) sfWhite = sfColor(255, 255, 255, 255);
	immutable(sfColor) sfRed = sfColor(255, 0, 0, 255);
	immutable(sfColor) sfGreen = sfColor(0, 255, 0, 255);
	immutable(sfColor) sfBlue = sfColor(0, 0, 255, 255);
	immutable(sfColor) sfYellow = sfColor(255, 255, 0, 255);
	immutable(sfColor) sfMagenta = sfColor(255, 0, 255, 255);
	immutable(sfColor) sfCyan = sfColor(0, 255, 255, 255);
	immutable(sfColor) sfTransparent = sfColor(0, 0, 0, 0);
}
struct sfFontInfo
{
	const(char)* family;
}
struct sfGlyph
{
	float advance;
	sfFloatRect bounds;
	sfIntRect textureRect;
}
alias int sfPrimitiveType;
enum 
{
	sfPoints,
	sfLines,
	sfLinesStrip,
	sfTriangles,
	sfTrianglesStrip,
	sfTrianglesFan,
	sfQuads,
}
struct sfFloatRect
{
	float left;
	float top;
	float width;
	float height;
}
struct sfIntRect
{
	int left;
	int top;
	int width;
	int height;
}
struct sfRenderStates
{
	sfBlendMode blendMode;
	sfTransform transform;
	const(sfTexture)* texture;
	const(sfShader)* shader;
}
extern (C) nothrow 
{
	alias size_t function(void*) sfShapeGetPointCountCallback;
	alias sfVector2f function(size_t, void*) sfShapeGetPointCallback;
}

alias int sfTextStyle;
enum 
{
	sfTextRegular = 0,
	sfTextBold = 1 << 0,
	sfTextItalic = 1 << 1,
	sfTextUnderlined = 1 << 2,
	sfTextStrikeThrough = 1 << 3,
}
struct sfTransform
{
	float[9] matrix;
}
const sfTransform sfTransform_Identity = sfTransform([1.00000F, 0x0.0000000000004p-1022F, 0x0.0000000000004p-1022F, 0x0.0000000000004p-1022F, 1.00000F, 0x0.0000000000004p-1022F, 0x0.0000000000004p-1022F, 0x0.0000000000004p-1022F, 1.00000F]);

struct sfVertex
{
	sfVector2f position;
	sfColor color;
	sfVector2f texCoords;
}
extern (C) nothrow @nogc 
{
	alias sfCircleShape* function() da_sfCircleShape_create;
	alias sfCircleShape* function(const(sfCircleShape)*) da_sfCircleShape_copy;
	alias void function(sfCircleShape*) da_sfCircleShape_destroy;
	alias void function(sfCircleShape*, sfVector2f) da_sfCircleShape_setPosition;
	alias void function(sfCircleShape*, float) da_sfCircleShape_setRotation;
	alias void function(sfCircleShape*, sfVector2f) da_sfCircleShape_setScale;
	alias void function(sfCircleShape*, sfVector2f) da_sfCircleShape_setOrigin;
	alias sfVector2f function(const(sfCircleShape)*) da_sfCircleShape_getPosition;
	alias float function(const(sfCircleShape)*) da_sfCircleShape_getRotation;
	alias sfVector2f function(const(sfCircleShape)*) da_sfCircleShape_getScale;
	alias sfVector2f function(const(sfCircleShape)*) da_sfCircleShape_getOrigin;
	alias void function(sfCircleShape*, sfVector2f) da_sfCircleShape_move;
	alias void function(sfCircleShape*, float) da_sfCircleShape_rotate;
	alias void function(sfCircleShape*, sfVector2f) da_sfCircleShape_scale;
	alias sfTransform function(const(sfCircleShape)*) da_sfCircleShape_getTransform;
	alias sfTransform function(const(sfCircleShape)*) da_sfCircleShape_getInverseTransform;
	alias void function(sfCircleShape*, const(sfTexture)*, sfBool) da_sfCircleShape_setTexture;
	alias void function(sfCircleShape*, sfIntRect) da_sfCircleShape_setTextureRect;
	alias void function(sfCircleShape*, sfColor) da_sfCircleShape_setFillColor;
	alias void function(sfCircleShape*, sfColor) da_sfCircleShape_setOutlineColor;
	alias void function(sfCircleShape*, float) da_sfCircleShape_setOutlineThickness;
	alias const(sfTexture)* function(const(sfCircleShape)*) da_sfCircleShape_getTexture;
	alias sfIntRect function(const(sfCircleShape)*) da_sfCircleShape_getTextureRect;
	alias sfColor function(const(sfCircleShape)*) da_sfCircleShape_getFillColor;
	alias sfColor function(const(sfCircleShape)*) da_sfCircleShape_getOutlineColor;
	alias float function(const(sfCircleShape)*) da_sfCircleShape_getOutlineThickness;
	alias size_t function(const(sfCircleShape)*) da_sfCircleShape_getPointCount;
	alias sfVector2f function(const(sfCircleShape)*, size_t) da_sfCircleShape_getPoint;
	alias void function(sfCircleShape*, float) da_sfCircleShape_setRadius;
	alias float function(const(sfCircleShape)*) da_sfCircleShape_getRadius;
	alias void function(sfCircleShape*, size_t) da_sfCircleShape_setPointCount;
	alias sfFloatRect function(const(sfCircleShape)*) da_sfCircleShape_getLocalBounds;
	alias sfFloatRect function(const(sfCircleShape)*) da_sfCircleShape_getGlobalBounds;
	alias sfColor function(sfUint8, sfUint8, sfUint8) da_sfColor_fromRGB;
	alias sfColor function(sfUint8, sfUint8, sfUint8, sfUint8) da_sfColor_fromRGBA;
	alias sfColor function(sfUint32) da_sfColor_fromInteger;
	alias sfUint32 function(sfColor) da_sfColor_toInteger;
	alias sfColor function(sfColor, sfColor) da_sfColor_add;
	alias sfColor function(sfColor, sfColor) da_sfColor_subtract;
	alias sfColor function(sfColor, sfColor) da_sfColor_modulate;
	alias sfConvexShape* function() da_sfConvexShape_create;
	alias sfConvexShape* function(const(sfConvexShape)*) da_sfConvexShape_copy;
	alias void function(sfConvexShape*) da_sfConvexShape_destroy;
	alias void function(sfConvexShape*, sfVector2f) da_sfConvexShape_setPosition;
	alias void function(sfConvexShape*, float) da_sfConvexShape_setRotation;
	alias void function(sfConvexShape*, sfVector2f) da_sfConvexShape_setScale;
	alias void function(sfConvexShape*, sfVector2f) da_sfConvexShape_setOrigin;
	alias sfVector2f function(const(sfConvexShape)*) da_sfConvexShape_getPosition;
	alias float function(const(sfConvexShape)*) da_sfConvexShape_getRotation;
	alias sfVector2f function(const(sfConvexShape)*) da_sfConvexShape_getScale;
	alias sfVector2f function(const(sfConvexShape)*) da_sfConvexShape_getOrigin;
	alias void function(sfConvexShape*, sfVector2f) da_sfConvexShape_move;
	alias void function(sfConvexShape*, float) da_sfConvexShape_rotate;
	alias void function(sfConvexShape*, sfVector2f) da_sfConvexShape_scale;
	alias sfTransform function(const(sfConvexShape)*) da_sfConvexShape_getTransform;
	alias sfTransform function(const(sfConvexShape)*) da_sfConvexShape_getInverseTransform;
	alias void function(sfConvexShape*, const(sfTexture)*, sfBool) da_sfConvexShape_setTexture;
	alias void function(sfConvexShape*, sfIntRect) da_sfConvexShape_setTextureRect;
	alias void function(sfConvexShape*, sfColor) da_sfConvexShape_setFillColor;
	alias void function(sfConvexShape*, sfColor) da_sfConvexShape_setOutlineColor;
	alias void function(sfConvexShape*, float) da_sfConvexShape_setOutlineThickness;
	alias const(sfTexture)* function(const(sfConvexShape)*) da_sfConvexShape_getTexture;
	alias sfIntRect function(const(sfConvexShape)*) da_sfConvexShape_getTextureRect;
	alias sfColor function(const(sfConvexShape)*) da_sfConvexShape_getFillColor;
	alias sfColor function(const(sfConvexShape)*) da_sfConvexShape_getOutlineColor;
	alias float function(const(sfConvexShape)*) da_sfConvexShape_getOutlineThickness;
	alias size_t function(const(sfConvexShape)*) da_sfConvexShape_getPointCount;
	alias sfVector2f function(const(sfConvexShape)*, size_t) da_sfConvexShape_getPoint;
	alias void function(sfConvexShape*, size_t) da_sfConvexShape_setPointCount;
	alias void function(sfConvexShape*, size_t, sfVector2f) da_sfConvexShape_setPoint;
	alias sfFloatRect function(const(sfConvexShape)*) da_sfConvexShape_getLocalBounds;
	alias sfFloatRect function(const(sfConvexShape)*) da_sfConvexShape_getGlobalBounds;
	alias sfFont* function(const(char)*) da_sfFont_createFromFile;
	alias sfFont* function(const(void)*, size_t) da_sfFont_createFromMemory;
	alias sfFont* function(sfInputStream*) da_sfFont_createFromStream;
	alias sfFont* function(const(sfFont)*) da_sfFont_copy;
	alias void function(sfFont*) da_sfFont_destroy;
	alias sfGlyph function(sfFont*, sfUint32, uint, sfBool) da_sfFont_getGlyph;
	alias float function(sfFont*, sfUint32, sfUint32, uint) da_sfFont_getKerning;
	alias float function(sfFont*, uint) da_sfFont_getLineSpacing;
	alias float function(sfFont*, uint) da_sfFont_getUnderlinePosition;
	alias float function(sfFont*, uint) da_sfFont_getUnderlineThickness;
	alias const(sfTexture)* function(sfFont*, uint) da_sfFont_getTexture;
	alias sfFontInfo function(const(sfFont)*) da_sfFont_getInfo;
	alias sfImage* function(uint, uint) da_sfImage_create;
	alias sfImage* function(uint, uint, sfColor) da_sfImage_createFromColor;
	alias sfImage* function(uint, uint, const(sfUint8)*) da_sfImage_createFromPixels;
	alias sfImage* function(const(char)*) da_sfImage_createFromFile;
	alias sfImage* function(const(void)*, size_t) da_sfImage_createFromMemory;
	alias sfImage* function(sfInputStream*) da_sfImage_createFromStream;
	alias sfImage* function(const(sfImage)*) da_sfImage_copy;
	alias void function(sfImage*) da_sfImage_destroy;
	alias sfBool function(const(sfImage)*, const(char)*) da_sfImage_saveToFile;
	alias sfVector2u function(const(sfImage)*) da_sfImage_getSize;
	alias void function(sfImage*, sfColor, sfUint8) da_sfImage_createMaskFromColor;
	alias void function(sfImage*, const(sfImage)*, uint, uint, sfIntRect, sfBool) da_sfImage_copyImage;
	alias void function(sfImage*, uint, uint, sfColor) da_sfImage_setPixel;
	alias sfColor function(const(sfImage)*, uint, uint) da_sfImage_getPixel;
	alias const(sfUint8)* function(const(sfImage)*) da_sfImage_getPixelsPtr;
	alias void function(sfImage*) da_sfImage_flipHorizontally;
	alias void function(sfImage*) da_sfImage_flipVertically;
	alias sfBool function(const(sfFloatRect)*, float, float) da_sfFloatRect_contains;
	alias sfBool function(const(sfIntRect)*, int, int) da_sfIntRect_contains;
	alias sfBool function(const(sfFloatRect)*, const(sfFloatRect)*, sfFloatRect*) da_sfFloatRect_intersects;
	alias sfBool function(const(sfIntRect)*, const(sfIntRect)*, sfIntRect*) da_sfIntRect_intersects;
	alias sfRectangleShape* function() da_sfRectangleShape_create;
	alias sfRectangleShape* function(const(sfRectangleShape)*) da_sfRectangleShape_copy;
	alias void function(sfRectangleShape*) da_sfRectangleShape_destroy;
	alias void function(sfRectangleShape*, sfVector2f) da_sfRectangleShape_setPosition;
	alias void function(sfRectangleShape*, float) da_sfRectangleShape_setRotation;
	alias void function(sfRectangleShape*, sfVector2f) da_sfRectangleShape_setScale;
	alias void function(sfRectangleShape*, sfVector2f) da_sfRectangleShape_setOrigin;
	alias sfVector2f function(const(sfRectangleShape)*) da_sfRectangleShape_getPosition;
	alias float function(const(sfRectangleShape)*) da_sfRectangleShape_getRotation;
	alias sfVector2f function(const(sfRectangleShape)*) da_sfRectangleShape_getScale;
	alias sfVector2f function(const(sfRectangleShape)*) da_sfRectangleShape_getOrigin;
	alias void function(sfRectangleShape*, sfVector2f) da_sfRectangleShape_move;
	alias void function(sfRectangleShape*, float) da_sfRectangleShape_rotate;
	alias void function(sfRectangleShape*, sfVector2f) da_sfRectangleShape_scale;
	alias sfTransform function(const(sfRectangleShape)*) da_sfRectangleShape_getTransform;
	alias sfTransform function(const(sfRectangleShape)*) da_sfRectangleShape_getInverseTransform;
	alias void function(sfRectangleShape*, const(sfTexture)*, sfBool) da_sfRectangleShape_setTexture;
	alias void function(sfRectangleShape*, sfIntRect) da_sfRectangleShape_setTextureRect;
	alias void function(sfRectangleShape*, sfColor) da_sfRectangleShape_setFillColor;
	alias void function(sfRectangleShape*, sfColor) da_sfRectangleShape_setOutlineColor;
	alias void function(sfRectangleShape*, float) da_sfRectangleShape_setOutlineThickness;
	alias const(sfTexture)* function(const(sfRectangleShape)*) da_sfRectangleShape_getTexture;
	alias sfIntRect function(const(sfRectangleShape)*) da_sfRectangleShape_getTextureRect;
	alias sfColor function(const(sfRectangleShape)*) da_sfRectangleShape_getFillColor;
	alias sfColor function(const(sfRectangleShape)*) da_sfRectangleShape_getOutlineColor;
	alias float function(const(sfRectangleShape)*) da_sfRectangleShape_getOutlineThickness;
	alias size_t function(const(sfRectangleShape)*) da_sfRectangleShape_getPointCount;
	alias sfVector2f function(const(sfRectangleShape)*, size_t) da_sfRectangleShape_getPoint;
	alias void function(sfRectangleShape*, sfVector2f) da_sfRectangleShape_setSize;
	alias sfVector2f function(const(sfRectangleShape)*) da_sfRectangleShape_getSize;
	alias sfFloatRect function(const(sfRectangleShape)*) da_sfRectangleShape_getLocalBounds;
	alias sfFloatRect function(const(sfRectangleShape)*) da_sfRectangleShape_getGlobalBounds;
	alias sfRenderTexture* function(uint, uint, sfBool) da_sfRenderTexture_create;
	alias void function(sfRenderTexture*) da_sfRenderTexture_destroy;
	alias sfVector2u function(const(sfRenderTexture)*) da_sfRenderTexture_getSize;
	alias sfBool function(sfRenderTexture*, sfBool) da_sfRenderTexture_setActive;
	alias void function(sfRenderTexture*) da_sfRenderTexture_display;
	alias void function(sfRenderTexture*, sfColor) da_sfRenderTexture_clear;
	alias void function(sfRenderTexture*, const(sfView)*) da_sfRenderTexture_setView;
	alias const(sfView)* function(const(sfRenderTexture)*) da_sfRenderTexture_getView;
	alias const(sfView)* function(const(sfRenderTexture)*) da_sfRenderTexture_getDefaultView;
	alias sfIntRect function(const(sfRenderTexture)*, const(sfView)*) da_sfRenderTexture_getViewport;
	alias sfVector2f function(const(sfRenderTexture)*, sfVector2i, const(sfView)*) da_sfRenderTexture_mapPixelToCoords;
	alias sfVector2i function(const(sfRenderTexture)*, sfVector2f, const(sfView)*) da_sfRenderTexture_mapCoordsToPixel;
	alias void function(sfRenderTexture*, const(sfSprite)*, const(sfRenderStates)*) da_sfRenderTexture_drawSprite;
	alias void function(sfRenderTexture*, const(sfText)*, const(sfRenderStates)*) da_sfRenderTexture_drawText;
	alias void function(sfRenderTexture*, const(sfShape)*, const(sfRenderStates)*) da_sfRenderTexture_drawShape;
	alias void function(sfRenderTexture*, const(sfCircleShape)*, const(sfRenderStates)*) da_sfRenderTexture_drawCircleShape;
	alias void function(sfRenderTexture*, const(sfConvexShape)*, const(sfRenderStates)*) da_sfRenderTexture_drawConvexShape;
	alias void function(sfRenderTexture*, const(sfRectangleShape)*, const(sfRenderStates)*) da_sfRenderTexture_drawRectangleShape;
	alias void function(sfRenderTexture*, const(sfVertexArray)*, const(sfRenderStates)*) da_sfRenderTexture_drawVertexArray;
	alias void function(sfRenderTexture*, const(sfVertex)*, size_t, sfPrimitiveType, const(sfRenderStates)*) da_sfRenderTexture_drawPrimitives;
	alias void function(sfRenderTexture*) da_sfRenderTexture_pushGLStates;
	alias void function(sfRenderTexture*) da_sfRenderTexture_popGLStates;
	alias void function(sfRenderTexture*) da_sfRenderTexture_resetGLStates;
	alias const(sfTexture)* function(const(sfRenderTexture)*) da_sfRenderTexture_getTexture;
	alias void function(sfRenderTexture*, sfBool) da_sfRenderTexture_setSmooth;
	alias sfBool function(const(sfRenderTexture)*) da_sfRenderTexture_isSmooth;
	alias void function(sfRenderTexture*, sfBool) da_sfRenderTexture_setRepeated;
	alias sfBool function(const(sfRenderTexture)*) da_sfRenderTexture_isRepeated;
	alias sfRenderWindow* function(sfVideoMode, const(char)*, sfUint32, const(sfContextSettings)*) da_sfRenderWindow_create;
	alias sfRenderWindow* function(sfVideoMode, const(dchar)*, sfUint32, const(sfContextSettings)*) da_sfRenderWindow_createUnicode;
	alias sfRenderWindow* function(sfWindowHandle, const(sfContextSettings)*) da_sfRenderWindow_createFromHandle;
	alias void function(sfRenderWindow*) da_sfRenderWindow_destroy;
	alias void function(sfRenderWindow*) da_sfRenderWindow_close;
	alias sfBool function(const(sfRenderWindow)*) da_sfRenderWindow_isOpen;
	alias sfContextSettings function(const(sfRenderWindow)*) da_sfRenderWindow_getSettings;
	alias sfBool function(sfRenderWindow* renderWindow, sfEvent*) da_sfRenderWindow_pollEvent;
	alias sfBool function(sfRenderWindow* renderWindow, sfEvent*) da_sfRenderWindow_waitEvent;
	alias sfVector2i function(const(sfRenderWindow)*) da_sfRenderWindow_getPosition;
	alias void function(sfRenderWindow*, sfVector2i) da_sfRenderWindow_setPosition;
	alias sfVector2u function(const(sfRenderWindow)*) da_sfRenderWindow_getSize;
	alias void function(sfRenderWindow*, sfVector2u) da_sfRenderWindow_setSize;
	alias void function(sfRenderWindow*, const(char)*) da_sfRenderWindow_setTitle;
	alias void function(sfRenderWindow*, uint, uint, const(sfUint8)*) da_sfRenderWindow_setIcon;
	alias void function(sfRenderWindow*, sfBool) da_sfRenderWindow_setVisible;
	alias void function(sfRenderWindow*, sfBool) da_sfRenderWindow_setMouseCursorVisible;
	alias void function(sfRenderWindow*, sfBool) da_sfRenderWindow_setVerticalSyncEnabled;
	alias void function(sfRenderWindow*, sfBool) da_sfRenderWindow_setKeyRepeatEnabled;
	alias sfBool function(sfRenderWindow*, sfBool) da_sfRenderWindow_setActive;
	alias void function(sfRenderWindow*) da_sfRenderWindow_requestFocus;
	alias sfBool function(const(sfRenderWindow)*) da_sfRenderWindow_hasFocus;
	alias void function(sfRenderWindow*) da_sfRenderWindow_display;
	alias void function(sfRenderWindow*, uint) da_sfRenderWindow_setFramerateLimit;
	alias void function(sfRenderWindow*, float) da_sfRenderWindow_setJoystickThreshold;
	alias sfWindowHandle function(const(sfRenderWindow)*) da_sfRenderWindow_getSystemHandle;
	alias void function(sfRenderWindow*, sfColor lor) da_sfRenderWindow_clear;
	alias void function(sfRenderWindow*, const(sfView)*) da_sfRenderWindow_setView;
	alias const(sfView)* function(const(sfRenderWindow)*) da_sfRenderWindow_getView;
	alias const(sfView)* function(const(sfRenderWindow)*) da_sfRenderWindow_getDefaultView;
	alias sfIntRect function(const(sfRenderWindow)*, const(sfView)*) da_sfRenderWindow_getViewport;
	alias sfVector2f function(const(sfRenderWindow)*, sfVector2i, const(sfView)*) da_sfRenderWindow_mapPixelToCoords;
	alias sfVector2i function(const(sfRenderWindow)*, sfVector2f, const(sfView)*) da_sfRenderWindow_mapCoordsToPixel;
	alias void function(sfRenderWindow*, const(sfSprite)*, const(sfRenderStates)*) da_sfRenderWindow_drawSprite;
	alias void function(sfRenderWindow*, const(sfText)*, const(sfRenderStates)*) da_sfRenderWindow_drawText;
	alias void function(sfRenderWindow*, const(sfShape)*, const(sfRenderStates)*) da_sfRenderWindow_drawShape;
	alias void function(sfRenderWindow*, const(sfCircleShape)*, const(sfRenderStates)*) da_sfRenderWindow_drawCircleShape;
	alias void function(sfRenderWindow*, const(sfConvexShape)*, const(sfRenderStates)*) da_sfRenderWindow_drawConvexShape;
	alias void function(sfRenderWindow*, const(sfRectangleShape)*, const(sfRenderStates)*) da_sfRenderWindow_drawRectangleShape;
	alias void function(sfRenderWindow*, const(sfVertexArray)*, const(sfRenderStates)*) da_sfRenderWindow_drawVertexArray;
	alias void function(sfRenderWindow*, sfVertex*, size_t, sfPrimitiveType, const(sfRenderStates)*) da_sfRenderWindow_drawPrimitives;
	alias void function(sfRenderWindow*) da_sfRenderWindow_pushGLStates;
	alias void function(sfRenderWindow*) da_sfRenderWindow_popGLStates;
	alias void function(sfRenderWindow*) da_sfRenderWindow_resetGLStates;
	alias sfImage* function(const(sfRenderWindow)*) da_sfRenderWindow_capture;
	alias sfVector2i function(const(sfRenderWindow)*) da_sfMouse_getPositionRenderWindow;
	alias void function(sfVector2i, const(sfRenderWindow)*) da_sfMouse_setPositionRenderWindow;
	alias sfVector2i function(uint, const(sfRenderWindow)*) da_sfTouch_getPositionRenderWindow;
	alias sfShader* function(const(char)*, const(char)*) da_sfShader_createFromFile;
	alias sfShader* function(const(char)*, const(char)*) da_sfShader_createFromMemory;
	alias sfShader* function(sfInputStream*, sfInputStream*) da_sfShader_createFromStream;
	alias void function(sfShader*) da_sfShader_destroy;
	alias void function(sfShader*, const(char)*, float) da_sfShader_setFloatParameter;
	alias void function(sfShader*, const(char)*, float, float) da_sfShader_setFloat2Parameter;
	alias void function(sfShader*, const(char)*, float, float, float) da_sfShader_setFloat3Parameter;
	alias void function(sfShader*, const(char)*, float, float, float, float) da_sfShader_setFloat4Parameter;
	alias void function(sfShader*, const(char)*, sfVector2f) da_sfShader_setVector2Parameter;
	alias void function(sfShader*, const(char)*, sfVector3f) da_sfShader_setVector3Parameter;
	alias void function(sfShader*, const(char)*, sfColor) da_sfShader_setColorParameter;
	alias void function(sfShader*, const(char)*, sfTransform) da_sfShader_setTransformParameter;
	alias void function(sfShader*, const(char)*, const(sfTexture)*) da_sfShader_setTextureParameter;
	alias void function(sfShader*, const(char)*) da_sfShader_setCurrentTextureParameter;
	alias uint function(const(sfShader)*) da_sfShader_getNativeHandle;
	alias void function(const(sfShader)*) da_sfShader_bind;
	alias sfBool function() da_sfShader_isAvailable;
	alias sfShape* function(sfShapeGetPointCountCallback, sfShapeGetPointCallback) da_sfShape_create;
	alias void function(sfShape*) da_sfShape_destroy;
	alias void function(sfShape*, sfVector2f) da_sfShape_setPosition;
	alias void function(sfShape*, float) da_sfShape_setRotation;
	alias void function(sfShape*, sfVector2f) da_sfShape_setScale;
	alias void function(sfShape*, sfVector2f) da_sfShape_setOrigin;
	alias sfVector2f function(const(sfShape)*) da_sfShape_getPosition;
	alias float function(const(sfShape)*) da_sfShape_getRotation;
	alias sfVector2f function(const(sfShape)*) da_sfShape_getScale;
	alias sfVector2f function(const(sfShape)*) da_sfShape_getOrigin;
	alias void function(sfShape*, sfVector2f) da_sfShape_move;
	alias void function(sfShape*, float) da_sfShape_rotate;
	alias void function(sfShape*, sfVector2f) da_sfShape_scale;
	alias sfTransform function(const(sfShape)*) da_sfShape_getTransform;
	alias sfTransform function(const(sfShape)*) da_sfShape_getInverseTransform;
	alias void function(sfShape*, const(sfTexture)*, sfBool) da_sfShape_setTexture;
	alias void function(sfShape*, sfIntRect) da_sfShape_setTextureRect;
	alias void function(sfShape*, sfColor) da_sfShape_setFillColor;
	alias void function(sfShape*, sfColor) da_sfShape_setOutlineColor;
	alias void function(sfShape*, float) da_sfShape_setOutlineThickness;
	alias const(sfTexture)* function(const(sfShape)*) da_sfShape_getTexture;
	alias sfIntRect function(const(sfShape)*) da_sfShape_getTextureRect;
	alias sfColor function(const(sfShape)*) da_sfShape_getFillColor;
	alias sfColor function(const(sfShape)*) da_sfShape_getOutlineColor;
	alias float function(const(sfShape)*) da_sfShape_getOutlineThickness;
	alias size_t function(const(sfShape)*) da_sfShape_getPointCount;
	alias sfVector2f function(const(sfShape)*, size_t) da_sfShape_getPoint;
	alias sfFloatRect function(const(sfShape)*) da_sfShape_getLocalBounds;
	alias sfFloatRect function(const(sfShape)*) da_sfShape_getGlobalBounds;
	alias void function(sfShape*) da_sfShape_update;
	alias sfSprite* function() da_sfSprite_create;
	alias sfSprite* function(const(sfSprite)*) da_sfSprite_copy;
	alias void function(sfSprite*) da_sfSprite_destroy;
	alias void function(sfSprite*, sfVector2f) da_sfSprite_setPosition;
	alias void function(sfSprite*, float) da_sfSprite_setRotation;
	alias void function(sfSprite*, sfVector2f) da_sfSprite_setScale;
	alias void function(sfSprite*, sfVector2f) da_sfSprite_setOrigin;
	alias sfVector2f function(const(sfSprite)*) da_sfSprite_getPosition;
	alias float function(const(sfSprite)*) da_sfSprite_getRotation;
	alias sfVector2f function(const(sfSprite)*) da_sfSprite_getScale;
	alias sfVector2f function(const(sfSprite)*) da_sfSprite_getOrigin;
	alias void function(sfSprite*, sfVector2f) da_sfSprite_move;
	alias void function(sfSprite*, float) da_sfSprite_rotate;
	alias void function(sfSprite*, sfVector2f) da_sfSprite_scale;
	alias sfTransform function(const(sfSprite)*) da_sfSprite_getTransform;
	alias sfTransform function(const(sfSprite)*) da_sfSprite_getInverseTransform;
	alias void function(sfSprite*, const(sfTexture)*, sfBool) da_sfSprite_setTexture;
	alias void function(sfSprite*, sfIntRect) da_sfSprite_setTextureRect;
	alias void function(sfSprite*, sfColor) da_sfSprite_setColor;
	alias const(sfTexture)* function(const(sfSprite)*) da_sfSprite_getTexture;
	alias sfIntRect function(const(sfSprite)*) da_sfSprite_getTextureRect;
	alias sfColor function(const(sfSprite)*) da_sfSprite_getColor;
	alias sfFloatRect function(const(sfSprite)*) da_sfSprite_getLocalBounds;
	alias sfFloatRect function(const(sfSprite)*) da_sfSprite_getGlobalBounds;
	alias sfText* function() da_sfText_create;
	alias sfText* function(const(sfText)*) da_sfText_copy;
	alias void function(sfText*) da_sfText_destroy;
	alias void function(sfText*, sfVector2f) da_sfText_setPosition;
	alias void function(sfText*, float) da_sfText_setRotation;
	alias void function(sfText*, sfVector2f) da_sfText_setScale;
	alias void function(sfText*, sfVector2f) da_sfText_setOrigin;
	alias sfVector2f function(const(sfText)*) da_sfText_getPosition;
	alias float function(const(sfText)*) da_sfText_getRotation;
	alias sfVector2f function(const(sfText)*) da_sfText_getScale;
	alias sfVector2f function(const(sfText)*) da_sfText_getOrigin;
	alias void function(sfText*, sfVector2f) da_sfText_move;
	alias void function(sfText*, float) da_sfText_rotate;
	alias void function(sfText*, sfVector2f) da_sfText_scale;
	alias sfTransform function(const(sfText)*) da_sfText_getTransform;
	alias sfTransform function(const(sfText)*) da_sfText_getInverseTransform;
	alias void function(sfText*, const(char)*) da_sfText_setString;
	alias void function(sfText*, const(dchar)*) da_sfText_setUnicodeString;
	alias void function(sfText*, const(sfFont)*) da_sfText_setFont;
	alias void function(sfText*, uint) da_sfText_setCharacterSize;
	alias void function(sfText*, sfUint32) da_sfText_setStyle;
	alias void function(sfText*, sfColor) da_sfText_setColor;
	alias const(char)* function(const(sfText)*) da_sfText_getString;
	alias const(dchar)* function(const(sfText)*) da_sfText_getUnicodeString;
	alias const(sfFont)* function(const(sfText)*) da_sfText_getFont;
	alias uint function(const(sfText)*) da_sfText_getCharacterSize;
	alias sfUint32 function(const(sfText)*) da_sfText_getStyle;
	alias sfColor function(const(sfText)*) da_sfText_getColor;
	alias sfVector2f function(const(sfText)*, size_t) da_sfText_findCharacterPos;
	alias sfFloatRect function(const(sfText)*) da_sfText_getLocalBounds;
	alias sfFloatRect function(const(sfText)*) da_sfText_getGlobalBounds;
	alias sfTexture* function(uint, uint) da_sfTexture_create;
	alias sfTexture* function(const(char)*, const(sfIntRect)*) da_sfTexture_createFromFile;
	alias sfTexture* function(const(void)*, size_t, const(sfIntRect)*) da_sfTexture_createFromMemory;
	alias sfTexture* function(sfInputStream*, const(sfIntRect)*) da_sfTexture_createFromStream;
	alias sfTexture* function(const(sfImage)*, const(sfIntRect)*) da_sfTexture_createFromImage;
	alias sfTexture* function(const(sfTexture)*) da_sfTexture_copy;
	alias void function(sfTexture*) da_sfTexture_destroy;
	alias sfVector2u function(const(sfTexture)*) da_sfTexture_getSize;
	alias sfImage* function(const(sfTexture)*) da_sfTexture_copyToImage;
	alias void function(sfTexture*, const(sfUint8)*, uint, uint, uint, uint) da_sfTexture_updateFromPixels;
	alias void function(sfTexture*, const(sfImage)*, uint, uint) da_sfTexture_updateFromImage;
	alias void function(sfTexture*, const(sfWindow)*, uint, uint) da_sfTexture_updateFromWindow;
	alias void function(sfTexture*, const(sfRenderWindow)* renderWindow, uint, uint) da_sfTexture_updateFromRenderWindow;
	alias void function(const(sfTexture)*) da_sfTexture_bind;
	alias void function(sfTexture*, sfBool) da_sfTexture_setSmooth;
	alias sfBool function(const(sfTexture)*) da_sfTexture_isSmooth;
	alias void function(sfTexture*, sfBool) da_sfTexture_setRepeated;
	alias sfBool function(const(sfTexture)*) da_sfTexture_isRepeated;
	alias uint function(const(sfTexture)*) da_sfTexture_getNativeHandle;
	alias uint function() da_sfTexture_getMaximumSize;
	alias sfTransform function(float, float, float, float, float, float, float, float, float) da_sfTransform_fromMatrix;
	alias void function(const(sfTransform)*, float*) da_sfTransform_getMatrix;
	alias sfTransform function(const(sfTransform)*) da_sfTransform_getInverse;
	alias sfVector2f function(const(sfTransform)*, sfVector2f) da_sfTransform_transformPoint;
	alias sfFloatRect function(const(sfTransform)*, sfFloatRect) da_sfTransform_transformRect;
	alias void function(sfTransform*, const(sfTransform)*) da_sfTransform_combine;
	alias void function(sfTransform*, float, float) da_sfTransform_translate;
	alias void function(sfTransform*, float) da_sfTransform_rotate;
	alias void function(sfTransform*, float, float, float) da_sfTransform_rotateWithCenter;
	alias void function(sfTransform*, float, float) da_sfTransform_scale;
	alias void function(sfTransform*, float, float, float, float) da_sfTransform_scaleWithCenter;
	alias sfTransformable* function() da_sfTransformable_create;
	alias sfTransformable* function(const(sfTransformable)*) da_sfTransformable_copy;
	alias void function(sfTransformable*) da_sfTransformable_destroy;
	alias void function(sfTransformable*, sfVector2f) da_sfTransformable_setPosition;
	alias void function(sfTransformable*, float) da_sfTransformable_setRotation;
	alias void function(sfTransformable*, sfVector2f) da_sfTransformable_setScale;
	alias void function(sfTransformable*, sfVector2f) da_sfTransformable_setOrigin;
	alias sfVector2f function(const(sfTransformable)*) da_sfTransformable_getPosition;
	alias float function(const(sfTransformable)*) da_sfTransformable_getRotation;
	alias sfVector2f function(const(sfTransformable)*) da_sfTransformable_getScale;
	alias sfVector2f function(const(sfTransformable)*) da_sfTransformable_getOrigin;
	alias void function(sfTransformable*, sfVector2f) da_sfTransformable_move;
	alias void function(sfTransformable*, float) da_sfTransformable_rotate;
	alias void function(sfTransformable*, sfVector2f) da_sfTransformable_scale;
	alias sfTransform function(const(sfTransformable)*) da_sfTransformable_getTransform;
	alias sfTransform function(const(sfTransformable)*) da_sfTransformable_getInverseTransform;
	alias sfVertexArray* function() da_sfVertexArray_create;
	alias sfVertexArray* function(const(sfVertexArray)*) da_sfVertexArray_copy;
	alias void function(sfVertexArray*) da_sfVertexArray_destroy;
	alias size_t function(const(sfVertexArray)*) da_sfVertexArray_getVertexCount;
	alias sfVertex* function(sfVertexArray*, size_t) da_sfVertexArray_getVertex;
	alias void function(sfVertexArray*) da_sfVertexArray_clear;
	alias void function(sfVertexArray*, size_t) da_sfVertexArray_resize;
	alias void function(sfVertexArray*, sfVertex) da_sfVertexArray_append;
	alias void function(sfVertexArray*, sfPrimitiveType) da_sfVertexArray_setPrimitiveType;
	alias sfPrimitiveType function(sfVertexArray*) da_sfVertexArray_getPrimitiveType;
	alias sfFloatRect function(sfVertexArray*) da_sfVertexArray_getBounds;
	alias sfView* function() da_sfView_create;
	alias sfView* function(sfFloatRect) da_sfView_createFromRect;
	alias sfView* function(const(sfView)*) da_sfView_copy;
	alias void function(sfView*) da_sfView_destroy;
	alias void function(sfView*, sfVector2f) da_sfView_setCenter;
	alias void function(sfView*, sfVector2f) da_sfView_setSize;
	alias void function(sfView*, float) da_sfView_setRotation;
	alias void function(sfView*, sfFloatRect) da_sfView_setViewport;
	alias void function(sfView*, sfFloatRect) da_sfView_reset;
	alias sfVector2f function(const(sfView)*) da_sfView_getCenter;
	alias sfVector2f function(const(sfView)*) da_sfView_getSize;
	alias float function(const(sfView)*) da_sfView_getRotation;
	alias sfFloatRect function(const(sfView)*) da_sfView_getViewport;
	alias void function(sfView*, sfVector2f) da_sfView_move;
	alias void function(sfView*, float) da_sfView_rotate;
	alias void function(sfView*, float) da_sfView_zoom;
}

__gshared 
{
	da_sfCircleShape_create sfCircleShape_create;
	da_sfCircleShape_copy sfCircleShape_copy;
	da_sfCircleShape_destroy sfCircleShape_destroy;
	da_sfCircleShape_setPosition sfCircleShape_setPosition;
	da_sfCircleShape_setRotation sfCircleShape_setRotation;
	da_sfCircleShape_setScale sfCircleShape_setScale;
	da_sfCircleShape_setOrigin sfCircleShape_setOrigin;
	da_sfCircleShape_getPosition sfCircleShape_getPosition;
	da_sfCircleShape_getRotation sfCircleShape_getRotation;
	da_sfCircleShape_getScale sfCircleShape_getScale;
	da_sfCircleShape_getOrigin sfCircleShape_getOrigin;
	da_sfCircleShape_move sfCircleShape_move;
	da_sfCircleShape_rotate sfCircleShape_rotate;
	da_sfCircleShape_scale sfCircleShape_scale;
	da_sfCircleShape_getTransform sfCircleShape_getTransform;
	da_sfCircleShape_getInverseTransform sfCircleShape_getInverseTransform;
	da_sfCircleShape_setTexture sfCircleShape_setTexture;
	da_sfCircleShape_setTextureRect sfCircleShape_setTextureRect;
	da_sfCircleShape_setFillColor sfCircleShape_setFillColor;
	da_sfCircleShape_setOutlineColor sfCircleShape_setOutlineColor;
	da_sfCircleShape_setOutlineThickness sfCircleShape_setOutlineThickness;
	da_sfCircleShape_getTexture sfCircleShape_getTexture;
	da_sfCircleShape_getTextureRect sfCircleShape_getTextureRect;
	da_sfCircleShape_getFillColor sfCircleShape_getFillColor;
	da_sfCircleShape_getOutlineColor sfCircleShape_getOutlineColor;
	da_sfCircleShape_getOutlineThickness sfCircleShape_getOutlineThickness;
	da_sfCircleShape_getPointCount sfCircleShape_getPointCount;
	da_sfCircleShape_getPoint sfCircleShape_getPoint;
	da_sfCircleShape_setRadius sfCircleShape_setRadius;
	da_sfCircleShape_getRadius sfCircleShape_getRadius;
	da_sfCircleShape_setPointCount sfCircleShape_setPointCount;
	da_sfCircleShape_getLocalBounds sfCircleShape_getLocalBounds;
	da_sfCircleShape_getGlobalBounds sfCircleShape_getGlobalBounds;
	da_sfColor_fromRGB sfColor_fromRGB;
	da_sfColor_fromRGBA sfColor_fromRGBA;
	da_sfColor_fromInteger sfColor_fromInteger;
	da_sfColor_toInteger sfColor_toInteger;
	da_sfColor_add sfColor_add;
	da_sfColor_subtract sfColor_subtract;
	da_sfColor_modulate sfColor_modulate;
	da_sfConvexShape_create sfConvexShape_create;
	da_sfConvexShape_copy sfConvexShape_copy;
	da_sfConvexShape_destroy sfConvexShape_destroy;
	da_sfConvexShape_setPosition sfConvexShape_setPosition;
	da_sfConvexShape_setRotation sfConvexShape_setRotation;
	da_sfConvexShape_setScale sfConvexShape_setScale;
	da_sfConvexShape_setOrigin sfConvexShape_setOrigin;
	da_sfConvexShape_getPosition sfConvexShape_getPosition;
	da_sfConvexShape_getRotation sfConvexShape_getRotation;
	da_sfConvexShape_getScale sfConvexShape_getScale;
	da_sfConvexShape_getOrigin sfConvexShape_getOrigin;
	da_sfConvexShape_move sfConvexShape_move;
	da_sfConvexShape_rotate sfConvexShape_rotate;
	da_sfConvexShape_scale sfConvexShape_scale;
	da_sfConvexShape_getTransform sfConvexShape_getTransform;
	da_sfConvexShape_getInverseTransform sfConvexShape_getInverseTransform;
	da_sfConvexShape_setTexture sfConvexShape_setTexture;
	da_sfConvexShape_setTextureRect sfConvexShape_setTextureRect;
	da_sfConvexShape_setFillColor sfConvexShape_setFillColor;
	da_sfConvexShape_setOutlineColor sfConvexShape_setOutlineColor;
	da_sfConvexShape_setOutlineThickness sfConvexShape_setOutlineThickness;
	da_sfConvexShape_getTexture sfConvexShape_getTexture;
	da_sfConvexShape_getTextureRect sfConvexShape_getTextureRect;
	da_sfConvexShape_getFillColor sfConvexShape_getFillColor;
	da_sfConvexShape_getOutlineColor sfConvexShape_getOutlineColor;
	da_sfConvexShape_getOutlineThickness sfConvexShape_getOutlineThickness;
	da_sfConvexShape_getPointCount sfConvexShape_getPointCount;
	da_sfConvexShape_getPoint sfConvexShape_getPoint;
	da_sfConvexShape_setPointCount sfConvexShape_setPointCount;
	da_sfConvexShape_setPoint sfConvexShape_setPoint;
	da_sfConvexShape_getLocalBounds sfConvexShape_getLocalBounds;
	da_sfConvexShape_getGlobalBounds sfConvexShape_getGlobalBounds;
	da_sfFont_createFromFile sfFont_createFromFile;
	da_sfFont_createFromMemory sfFont_createFromMemory;
	da_sfFont_createFromStream sfFont_createFromStream;
	da_sfFont_copy sfFont_copy;
	da_sfFont_destroy sfFont_destroy;
	da_sfFont_getGlyph sfFont_getGlyph;
	da_sfFont_getKerning sfFont_getKerning;
	da_sfFont_getLineSpacing sfFont_getLineSpacing;
	da_sfFont_getUnderlinePosition sfFont_getUnderlinePosition;
	da_sfFont_getUnderlineThickness sfFont_getUnderlineThickness;
	da_sfFont_getTexture sfFont_getTexture;
	da_sfFont_getInfo sfFont_getInfo;
	da_sfImage_create sfImage_create;
	da_sfImage_createFromColor sfImage_createFromColor;
	da_sfImage_createFromPixels sfImage_createFromPixels;
	da_sfImage_createFromFile sfImage_createFromFile;
	da_sfImage_createFromMemory sfImage_createFromMemory;
	da_sfImage_createFromStream sfImage_createFromStream;
	da_sfImage_copy sfImage_copy;
	da_sfImage_destroy sfImage_destroy;
	da_sfImage_saveToFile sfImage_saveToFile;
	da_sfImage_getSize sfImage_getSize;
	da_sfImage_createMaskFromColor sfImage_createMaskFromColor;
	da_sfImage_copyImage sfImage_copyImage;
	da_sfImage_setPixel sfImage_setPixel;
	da_sfImage_getPixel sfImage_getPixel;
	da_sfImage_getPixelsPtr sfImage_getPixelsPtr;
	da_sfImage_flipHorizontally sfImage_flipHorizontally;
	da_sfImage_flipVertically sfImage_flipVertically;
	da_sfFloatRect_contains sfFloatRect_contains;
	da_sfIntRect_contains sfIntRect_contains;
	da_sfFloatRect_intersects sfFloatRect_intersects;
	da_sfIntRect_intersects sfIntRect_intersects;
	da_sfRectangleShape_create sfRectangleShape_create;
	da_sfRectangleShape_copy sfRectangleShape_copy;
	da_sfRectangleShape_destroy sfRectangleShape_destroy;
	da_sfRectangleShape_setPosition sfRectangleShape_setPosition;
	da_sfRectangleShape_setRotation sfRectangleShape_setRotation;
	da_sfRectangleShape_setScale sfRectangleShape_setScale;
	da_sfRectangleShape_setOrigin sfRectangleShape_setOrigin;
	da_sfRectangleShape_getPosition sfRectangleShape_getPosition;
	da_sfRectangleShape_getRotation sfRectangleShape_getRotation;
	da_sfRectangleShape_getScale sfRectangleShape_getScale;
	da_sfRectangleShape_getOrigin sfRectangleShape_getOrigin;
	da_sfRectangleShape_move sfRectangleShape_move;
	da_sfRectangleShape_rotate sfRectangleShape_rotate;
	da_sfRectangleShape_scale sfRectangleShape_scale;
	da_sfRectangleShape_getTransform sfRectangleShape_getTransform;
	da_sfRectangleShape_getInverseTransform sfRectangleShape_getInverseTransform;
	da_sfRectangleShape_setTexture sfRectangleShape_setTexture;
	da_sfRectangleShape_setTextureRect sfRectangleShape_setTextureRect;
	da_sfRectangleShape_setFillColor sfRectangleShape_setFillColor;
	da_sfRectangleShape_setOutlineColor sfRectangleShape_setOutlineColor;
	da_sfRectangleShape_setOutlineThickness sfRectangleShape_setOutlineThickness;
	da_sfRectangleShape_getTexture sfRectangleShape_getTexture;
	da_sfRectangleShape_getTextureRect sfRectangleShape_getTextureRect;
	da_sfRectangleShape_getFillColor sfRectangleShape_getFillColor;
	da_sfRectangleShape_getOutlineColor sfRectangleShape_getOutlineColor;
	da_sfRectangleShape_getOutlineThickness sfRectangleShape_getOutlineThickness;
	da_sfRectangleShape_getPointCount sfRectangleShape_getPointCount;
	da_sfRectangleShape_getPoint sfRectangleShape_getPoint;
	da_sfRectangleShape_setSize sfRectangleShape_setSize;
	da_sfRectangleShape_getSize sfRectangleShape_getSize;
	da_sfRectangleShape_getLocalBounds sfRectangleShape_getLocalBounds;
	da_sfRectangleShape_getGlobalBounds sfRectangleShape_getGlobalBounds;
	da_sfRenderTexture_create sfRenderTexture_create;
	da_sfRenderTexture_destroy sfRenderTexture_destroy;
	da_sfRenderTexture_getSize sfRenderTexture_getSize;
	da_sfRenderTexture_setActive sfRenderTexture_setActive;
	da_sfRenderTexture_display sfRenderTexture_display;
	da_sfRenderTexture_clear sfRenderTexture_clear;
	da_sfRenderTexture_setView sfRenderTexture_setView;
	da_sfRenderTexture_getView sfRenderTexture_getView;
	da_sfRenderTexture_getDefaultView sfRenderTexture_getDefaultView;
	da_sfRenderTexture_getViewport sfRenderTexture_getViewport;
	da_sfRenderTexture_mapPixelToCoords sfRenderTexture_mapPixelToCoords;
	da_sfRenderTexture_mapPixelToCoords sfRenderTexture_mapCoordsToPixel;
	da_sfRenderTexture_drawSprite sfRenderTexture_drawSprite;
	da_sfRenderTexture_drawText sfRenderTexture_drawText;
	da_sfRenderTexture_drawShape sfRenderTexture_drawShape;
	da_sfRenderTexture_drawCircleShape sfRenderTexture_drawCircleShape;
	da_sfRenderTexture_drawConvexShape sfRenderTexture_drawConvexShape;
	da_sfRenderTexture_drawRectangleShape sfRenderTexture_drawRectangleShape;
	da_sfRenderTexture_drawVertexArray sfRenderTexture_drawVertexArray;
	da_sfRenderTexture_drawPrimitives sfRenderTexture_drawPrimitives;
	da_sfRenderTexture_pushGLStates sfRenderTexture_pushGLStates;
	da_sfRenderTexture_popGLStates sfRenderTexture_popGLStates;
	da_sfRenderTexture_resetGLStates sfRenderTexture_resetGLStates;
	da_sfRenderTexture_getTexture sfRenderTexture_getTexture;
	da_sfRenderTexture_setSmooth sfRenderTexture_setSmooth;
	da_sfRenderTexture_isSmooth sfRenderTexture_isSmooth;
	da_sfRenderTexture_setRepeated sfRenderTexture_setRepeated;
	da_sfRenderTexture_isRepeated sfRenderTexture_isRepeated;
	da_sfRenderWindow_create sfRenderWindow_create;
	da_sfRenderWindow_createUnicode sfRenderWindow_createUnicode;
	da_sfRenderWindow_createFromHandle sfRenderWindow_createFromHandle;
	da_sfRenderWindow_destroy sfRenderWindow_destroy;
	da_sfRenderWindow_close sfRenderWindow_close;
	da_sfRenderWindow_isOpen sfRenderWindow_isOpen;
	da_sfRenderWindow_getSettings sfRenderWindow_getSettings;
	da_sfRenderWindow_pollEvent sfRenderWindow_pollEvent;
	da_sfRenderWindow_waitEvent sfRenderWindow_waitEvent;
	da_sfRenderWindow_getPosition sfRenderWindow_getPosition;
	da_sfRenderWindow_setPosition sfRenderWindow_setPosition;
	da_sfRenderWindow_getSize sfRenderWindow_getSize;
	da_sfRenderWindow_setSize sfRenderWindow_setSize;
	da_sfRenderWindow_setTitle sfRenderWindow_setTitle;
	da_sfRenderWindow_setIcon sfRenderWindow_setIcon;
	da_sfRenderWindow_setVisible sfRenderWindow_setVisible;
	da_sfRenderWindow_setMouseCursorVisible sfRenderWindow_setMouseCursorVisible;
	da_sfRenderWindow_setVerticalSyncEnabled sfRenderWindow_setVerticalSyncEnabled;
	da_sfRenderWindow_setKeyRepeatEnabled sfRenderWindow_setKeyRepeatEnabled;
	da_sfRenderWindow_setActive sfRenderWindow_setActive;
	da_sfRenderWindow_requestFocus sfRenderWindow_requestFocus;
	da_sfRenderWindow_hasFocus sfRenderWindow_hasFocus;
	da_sfRenderWindow_display sfRenderWindow_display;
	da_sfRenderWindow_setFramerateLimit sfRenderWindow_setFramerateLimit;
	da_sfRenderWindow_setJoystickThreshold sfRenderWindow_setJoystickThreshold;
	da_sfRenderWindow_getSystemHandle sfRenderWindow_getSystemHandle;
	da_sfRenderWindow_clear sfRenderWindow_clear;
	da_sfRenderWindow_setView sfRenderWindow_setView;
	da_sfRenderWindow_getView sfRenderWindow_getView;
	da_sfRenderWindow_getDefaultView sfRenderWindow_getDefaultView;
	da_sfRenderWindow_getViewport sfRenderWindow_getViewport;
	da_sfRenderWindow_mapPixelToCoords sfRenderWindow_mapPixelToCoords;
	da_sfRenderWindow_mapCoordsToPixel sfRenderWindow_mapCoordsToPixel;
	da_sfRenderWindow_drawSprite sfRenderWindow_drawSprite;
	da_sfRenderWindow_drawText sfRenderWindow_drawText;
	da_sfRenderWindow_drawShape sfRenderWindow_drawShape;
	da_sfRenderWindow_drawCircleShape sfRenderWindow_drawCircleShape;
	da_sfRenderWindow_drawConvexShape sfRenderWindow_drawConvexShape;
	da_sfRenderWindow_drawRectangleShape sfRenderWindow_drawRectangleShape;
	da_sfRenderWindow_drawVertexArray sfRenderWindow_drawVertexArray;
	da_sfRenderWindow_drawPrimitives sfRenderWindow_drawPrimitives;
	da_sfRenderWindow_pushGLStates sfRenderWindow_pushGLStates;
	da_sfRenderWindow_popGLStates sfRenderWindow_popGLStates;
	da_sfRenderWindow_resetGLStates sfRenderWindow_resetGLStates;
	da_sfRenderWindow_capture sfRenderWindow_capture;
	da_sfMouse_getPositionRenderWindow sfMouse_getPositionRenderWindow;
	da_sfMouse_setPositionRenderWindow sfMouse_setPositionRenderWindow;
	da_sfTouch_getPositionRenderWindow sfTouch_getPositionRenderWindow;
	da_sfShader_createFromFile sfShader_createFromFile;
	da_sfShader_createFromMemory sfShader_createFromMemory;
	da_sfShader_createFromStream sfShader_createFromStream;
	da_sfShader_destroy sfShader_destroy;
	da_sfShader_setFloatParameter sfShader_setFloatParameter;
	da_sfShader_setFloat2Parameter sfShader_setFloat2Parameter;
	da_sfShader_setFloat3Parameter sfShader_setFloat3Parameter;
	da_sfShader_setFloat4Parameter sfShader_setFloat4Parameter;
	da_sfShader_setVector2Parameter sfShader_setVector2Parameter;
	da_sfShader_setVector3Parameter sfShader_setVector3Parameter;
	da_sfShader_setColorParameter sfShader_setColorParameter;
	da_sfShader_setTransformParameter sfShader_setTransformParameter;
	da_sfShader_setTextureParameter sfShader_setTextureParameter;
	da_sfShader_setCurrentTextureParameter sfShader_setCurrentTextureParameter;
	da_sfShader_getNativeHandle sfShader_getNativeHandle;
	da_sfShader_bind sfShader_bind;
	da_sfShader_isAvailable sfShader_isAvailable;
	da_sfShape_create sfShape_create;
	da_sfShape_destroy sfShape_destroy;
	da_sfShape_setPosition sfShape_setPosition;
	da_sfShape_setRotation sfShape_setRotation;
	da_sfShape_setScale sfShape_setScale;
	da_sfShape_setOrigin sfShape_setOrigin;
	da_sfShape_getPosition sfShape_getPosition;
	da_sfShape_getRotation sfShape_getRotation;
	da_sfShape_getScale sfShape_getScale;
	da_sfShape_getOrigin sfShape_getOrigin;
	da_sfShape_move sfShape_move;
	da_sfShape_rotate sfShape_rotate;
	da_sfShape_scale sfShape_scale;
	da_sfShape_getTransform sfShape_getTransform;
	da_sfShape_getInverseTransform sfShape_getInverseTransform;
	da_sfShape_setTexture sfShape_setTexture;
	da_sfShape_setTextureRect sfShape_setTextureRect;
	da_sfShape_setFillColor sfShape_setFillColor;
	da_sfShape_setOutlineColor sfShape_setOutlineColor;
	da_sfShape_setOutlineThickness sfShape_setOutlineThickness;
	da_sfShape_getTexture sfShape_getTexture;
	da_sfShape_getTextureRect sfShape_getTextureRect;
	da_sfShape_getFillColor sfShape_getFillColor;
	da_sfShape_getOutlineColor sfShape_getOutlineColor;
	da_sfShape_getOutlineThickness sfShape_getOutlineThickness;
	da_sfShape_getPointCount sfShape_getPointCount;
	da_sfShape_getPoint sfShape_getPoint;
	da_sfShape_getLocalBounds sfShape_getLocalBounds;
	da_sfShape_getGlobalBounds sfShape_getGlobalBounds;
	da_sfShape_update sfShape_update;
	da_sfSprite_create sfSprite_create;
	da_sfSprite_copy sfSprite_copy;
	da_sfSprite_destroy sfSprite_destroy;
	da_sfSprite_setPosition sfSprite_setPosition;
	da_sfSprite_setRotation sfSprite_setRotation;
	da_sfSprite_setScale sfSprite_setScale;
	da_sfSprite_setOrigin sfSprite_setOrigin;
	da_sfSprite_getPosition sfSprite_getPosition;
	da_sfSprite_getRotation sfSprite_getRotation;
	da_sfSprite_getScale sfSprite_getScale;
	da_sfSprite_getOrigin sfSprite_getOrigin;
	da_sfSprite_move sfSprite_move;
	da_sfSprite_rotate sfSprite_rotate;
	da_sfSprite_scale sfSprite_scale;
	da_sfSprite_getTransform sfSprite_getTransform;
	da_sfSprite_getInverseTransform sfSprite_getInverseTransform;
	da_sfSprite_setTexture sfSprite_setTexture;
	da_sfSprite_setTextureRect sfSprite_setTextureRect;
	da_sfSprite_setColor sfSprite_setColor;
	da_sfSprite_getTexture sfSprite_getTexture;
	da_sfSprite_getTextureRect sfSprite_getTextureRect;
	da_sfSprite_getColor sfSprite_getColor;
	da_sfSprite_getLocalBounds sfSprite_getLocalBounds;
	da_sfSprite_getGlobalBounds sfSprite_getGlobalBounds;
	da_sfText_create sfText_create;
	da_sfText_copy sfText_copy;
	da_sfText_destroy sfText_destroy;
	da_sfText_setPosition sfText_setPosition;
	da_sfText_setRotation sfText_setRotation;
	da_sfText_setScale sfText_setScale;
	da_sfText_setOrigin sfText_setOrigin;
	da_sfText_getPosition sfText_getPosition;
	da_sfText_getRotation sfText_getRotation;
	da_sfText_getScale sfText_getScale;
	da_sfText_getOrigin sfText_getOrigin;
	da_sfText_move sfText_move;
	da_sfText_rotate sfText_rotate;
	da_sfText_scale sfText_scale;
	da_sfText_getTransform sfText_getTransform;
	da_sfText_getInverseTransform sfText_getInverseTransform;
	da_sfText_setString sfText_setString;
	da_sfText_setUnicodeString sfText_setUnicodeString;
	da_sfText_setFont sfText_setFont;
	da_sfText_setCharacterSize sfText_setCharacterSize;
	da_sfText_setStyle sfText_setStyle;
	da_sfText_setColor sfText_setColor;
	da_sfText_getString sfText_getString;
	da_sfText_getUnicodeString sfText_getUnicodeString;
	da_sfText_getFont sfText_getFont;
	da_sfText_getCharacterSize sfText_getCharacterSize;
	da_sfText_getStyle sfText_getStyle;
	da_sfText_getColor sfText_getColor;
	da_sfText_findCharacterPos sfText_findCharacterPos;
	da_sfText_getLocalBounds sfText_getLocalBounds;
	da_sfText_getGlobalBounds sfText_getGlobalBounds;
	da_sfTexture_create sfTexture_create;
	da_sfTexture_createFromFile sfTexture_createFromFile;
	da_sfTexture_createFromMemory sfTexture_createFromMemory;
	da_sfTexture_createFromStream sfTexture_createFromStream;
	da_sfTexture_createFromImage sfTexture_createFromImage;
	da_sfTexture_copy sfTexture_copy;
	da_sfTexture_destroy sfTexture_destroy;
	da_sfTexture_getSize sfTexture_getSize;
	da_sfTexture_copyToImage sfTexture_copyToImage;
	da_sfTexture_updateFromPixels sfTexture_updateFromPixels;
	da_sfTexture_updateFromImage sfTexture_updateFromImage;
	da_sfTexture_updateFromWindow sfTexture_updateFromWindow;
	da_sfTexture_updateFromRenderWindow sfTexture_updateFromRenderWindow;
	da_sfTexture_bind sfTexture_bind;
	da_sfTexture_setSmooth sfTexture_setSmooth;
	da_sfTexture_isSmooth sfTexture_isSmooth;
	da_sfTexture_setRepeated sfTexture_setRepeated;
	da_sfTexture_isRepeated sfTexture_isRepeated;
	da_sfTexture_getNativeHandle sfTexture_getNativeHandle;
	da_sfTexture_getMaximumSize sfTexture_getMaximumSize;
	da_sfTransform_fromMatrix sfTransform_fromMatrix;
	da_sfTransform_getMatrix sfTransform_getMatrix;
	da_sfTransform_getInverse sfTransform_getInverse;
	da_sfTransform_transformPoint sfTransform_transformPoint;
	da_sfTransform_transformRect sfTransform_transformRect;
	da_sfTransform_combine sfTransform_combine;
	da_sfTransform_translate sfTransform_translate;
	da_sfTransform_rotate sfTransform_rotate;
	da_sfTransform_rotateWithCenter sfTransform_rotateWithCenter;
	da_sfTransform_scale sfTransform_scale;
	da_sfTransform_scaleWithCenter sfTransform_scaleWithCenter;
	da_sfTransformable_create sfTransformable_create;
	da_sfTransformable_copy sfTransformable_copy;
	da_sfTransformable_destroy sfTransformable_destroy;
	da_sfTransformable_setPosition sfTransformable_setPosition;
	da_sfTransformable_setRotation sfTransformable_setRotation;
	da_sfTransformable_setScale sfTransformable_setScale;
	da_sfTransformable_setOrigin sfTransformable_setOrigin;
	da_sfTransformable_getPosition sfTransformable_getPosition;
	da_sfTransformable_getRotation sfTransformable_getRotation;
	da_sfTransformable_getScale sfTransformable_getScale;
	da_sfTransformable_getOrigin sfTransformable_getOrigin;
	da_sfTransformable_move sfTransformable_move;
	da_sfTransformable_rotate sfTransformable_rotate;
	da_sfTransformable_scale sfTransformable_scale;
	da_sfTransformable_getTransform sfTransformable_getTransform;
	da_sfTransformable_getInverseTransform sfTransformable_getInverseTransform;
	da_sfVertexArray_create sfVertexArray_create;
	da_sfVertexArray_copy sfVertexArray_copy;
	da_sfVertexArray_destroy sfVertexArray_destroy;
	da_sfVertexArray_getVertexCount sfVertexArray_getVertexCount;
	da_sfVertexArray_getVertex sfVertexArray_getVertex;
	da_sfVertexArray_clear sfVertexArray_clear;
	da_sfVertexArray_resize sfVertexArray_resize;
	da_sfVertexArray_append sfVertexArray_append;
	da_sfVertexArray_setPrimitiveType sfVertexArray_setPrimitiveType;
	da_sfVertexArray_getPrimitiveType sfVertexArray_getPrimitiveType;
	da_sfVertexArray_getBounds sfVertexArray_getBounds;
	da_sfView_create sfView_create;
	da_sfView_createFromRect sfView_createFromRect;
	da_sfView_copy sfView_copy;
	da_sfView_destroy sfView_destroy;
	da_sfView_setCenter sfView_setCenter;
	da_sfView_setSize sfView_setSize;
	da_sfView_setRotation sfView_setRotation;
	da_sfView_setViewport sfView_setViewport;
	da_sfView_reset sfView_reset;
	da_sfView_getCenter sfView_getCenter;
	da_sfView_getSize sfView_getSize;
	da_sfView_getRotation sfView_getRotation;
	da_sfView_getViewport sfView_getViewport;
	da_sfView_move sfView_move;
	da_sfView_rotate sfView_rotate;
	da_sfView_zoom sfView_zoom;
}
class DerelictSFML2GraphicsLoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();

}
__gshared DerelictSFML2GraphicsLoader DerelictSFML2Graphics;

shared static this();
