// D import file generated from 'derelict/sfml2/system.d'
module derelict.sfml2.system;
public import derelict.util.loader;

private 
{
	import derelict.util.system;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "csfml-system.dll,csfml-system-2.dll,csfml-system-2.3.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libcsfml-system.dylib,libcsfml-system.2.dylib,libcsfml-system.2.3.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libcsfml-system.so,libcsfml-system.so.2,libcsfml-system.so.2.3";
			}
			else
			{
				static assert(0, "Need to implement SFML2 System libNames for this operating system.");
			}
		}
	}
}
enum CSFML_VERSION_MAJOR = 2;
enum CSFML_VERSION_MINOR = 3;
alias int sfBool;
enum sfFalse = 0;
enum sfTrue = 1;
alias byte sfInt8;
alias ubyte sfUint8;
alias short sfInt16;
alias ushort sfUint16;
alias int sfInt32;
alias uint sfUint32;
alias long sfInt64;
alias ulong sfUint64;
struct sfClock;
struct sfMutex;
struct sfThread;
extern (C) nothrow 
{
	alias sfInt64 function(void*, sfInt64, void*) sfInputStreamReadFunc;
	alias sfInt64 function(sfInt64, void*) sfInputStreamSeekFunc;
	alias sfInt64 function(void*) sfInputStreamTellFunc;
	alias sfInt64 function(void*) sfInputStreamGetSizeFunc;
}

struct sfInputStream
{
	sfInputStreamReadFunc read;
	sfInputStreamSeekFunc seek;
	sfInputStreamTellFunc tell;
	sfInputStreamGetSizeFunc getSize;
	void* userData;
}
struct sfTime
{
	sfInt64 microseconds;
}
immutable(sfTime) sfTime_Zero;
struct sfVector2i
{
	int x;
	int y;
}
struct sfVector2u
{
	uint x;
	uint y;
}
struct sfVector2f
{
	float x;
	float y;
}
struct sfVector3f
{
	float x;
	float y;
	float z;
}
extern (C) nothrow @nogc 
{
	alias sfClock* function() da_sfClock_create;
	alias sfClock* function(const(sfClock)*) da_sfClock_copy;
	alias void function(sfClock*) da_sfClock_destroy;
	alias sfTime function(const(sfClock*)) da_sfClock_getElapsedTime;
	alias sfTime function(sfClock*) da_sfClock_restart;
	alias sfMutex* function() da_sfMutex_create;
	alias void function(sfMutex*) da_sfMutex_destroy;
	alias void function(sfMutex*) da_sfMutex_lock;
	alias void function(sfMutex*) da_sfMutex_unlock;
	alias void function(sfTime) da_sfSleep;
	alias sfThread* function(void function(void*), void*) da_sfThread_create;
	alias void function(sfThread*) da_sfThread_destroy;
	alias void function(sfThread*) da_sfThread_launch;
	alias void function(sfThread*) da_sfThread_wait;
	alias void function(sfThread*) da_sfThread_terminate;
	alias float function(sfTime) da_sfTime_asSeconds;
	alias sfInt32 function(sfTime) da_sfTime_asMilliseconds;
	alias sfInt64 function(sfTime) da_sfTime_asMicroseconds;
	alias sfTime function(float) da_sfSeconds;
	alias sfTime function(sfInt32) da_sfMilliseconds;
	alias sfTime function(sfInt64) da_sfMicroseconds;
}

__gshared 
{
	da_sfClock_create sfClock_create;
	da_sfClock_copy sfClock_copy;
	da_sfClock_destroy sfClock_destroy;
	da_sfClock_getElapsedTime sfClock_getElapsedTime;
	da_sfClock_restart sfClock_restart;
	da_sfMutex_create sfMutex_create;
	da_sfMutex_destroy sfMutex_destroy;
	da_sfMutex_lock sfMutex_lock;
	da_sfMutex_unlock sfMutex_unlock;
	da_sfSleep sfSleep;
	da_sfThread_create sfThread_create;
	da_sfThread_destroy sfThread_destroy;
	da_sfThread_launch sfThread_launch;
	da_sfThread_wait sfThread_wait;
	da_sfThread_terminate sfThread_terminate;
	da_sfTime_asSeconds sfTime_asSeconds;
	da_sfTime_asMilliseconds sfTime_asMilliseconds;
	da_sfTime_asMicroseconds sfTime_asMicroseconds;
	da_sfSeconds sfSeconds;
	da_sfMilliseconds sfMilliseconds;
	da_sfMicroseconds sfMicroseconds;
}
class DerelictSFML2SystemLoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();

}
__gshared DerelictSFML2SystemLoader DerelictSFML2System;

shared static this();
