// D import file generated from 'derelict/sfml2/window.d'
module derelict.sfml2.window;
public import derelict.util.loader;

private 
{
	import derelict.util.exception;
	import derelict.util.system;
	import derelict.sfml2.system;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "csfml-window.dll,csfml-window-2.dll,csfml-window-2.3.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libcsfml-window.dylib,libcsfml-window.2.dylib,libcsfml-window.2.3.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libcsfml-window.so,libcsfml-window.so.2,libcsfml-window.so.2.3";
			}
			else
			{
				static assert(0, "Need to implement SFML2 Window libNames for this operating system.");
			}
		}
	}
}
struct sfContext;
struct sfWindow;
alias int sfEventType;
enum 
{
	sfEvtClosed,
	sfEvtResized,
	sfEvtLostFocus,
	sfEvtGainedFocus,
	sfEvtTextEntered,
	sfEvtKeyPressed,
	sfEvtKeyReleased,
	sfEvtMouseWheelMoved,
	sfEvtMouseWheelScrolled,
	sfEvtMouseButtonPressed,
	sfEvtMouseButtonReleased,
	sfEvtMouseMoved,
	sfEvtMouseEntered,
	sfEvtMouseLeft,
	sfEvtJoystickButtonPressed,
	sfEvtJoystickButtonReleased,
	sfEvtJoystickMoved,
	sfEvtJoystickConnected,
	sfEvtJoystickDisconnected,
	sfEvtTouchBegan,
	sfEvtTouchMoved,
	sfEvtTouchEnded,
	sfEvtSensorChanged,
	sfEvtCount,
}
struct sfKeyEvent
{
	sfEventType type;
	sfKeyCode code;
	sfBool alt;
	sfBool control;
	sfBool shift;
	sfBool system;
}
struct sfTextEvent
{
	sfEventType type;
	sfUint32 unicode;
}
struct sfMouseMoveEvent
{
	sfEventType type;
	int x;
	int y;
}
struct sfMouseButtonEvent
{
	sfEventType type;
	sfMouseButton button;
	int x;
	int y;
}
struct sfMouseWheelEvent
{
	sfEventType type;
	int delta;
	int x;
	int y;
}
struct sfMouseWheelScrollEvent
{
	sfEventType type;
	sfMouseWheel wheel;
	float delta;
	int x;
	int y;
}
struct sfJoystickMoveEvent
{
	sfEventType type;
	uint joystickId;
	sfJoystickAxis axis;
	float position;
}
struct sfJoystickButtonEvent
{
	sfEventType type;
	uint joystickId;
	uint button;
}
struct sfJoystickConnectEvent
{
	sfEventType type;
	uint joystickId;
}
struct sfSizeEvent
{
	sfEventType type;
	uint width;
	uint height;
}
struct sfTouchEvent
{
	sfEventType type;
	uint finger;
	int x;
	int y;
}
struct sfSensorEvent
{
	sfEventType type;
	sfSensorType sensorType;
	float x;
	float y;
	float z;
}
union sfEvent
{
	sfEventType type;
	sfSizeEvent size;
	sfKeyEvent key;
	sfTextEvent text;
	sfMouseMoveEvent mouseMove;
	sfMouseButtonEvent mouseButton;
	sfMouseWheelEvent mouseWheel;
	sfMouseWheelScrollEvent mouseWheelScroll;
	sfJoystickMoveEvent joystickMove;
	sfJoystickButtonEvent joystickButton;
	sfJoystickConnectEvent joystickConnect;
	sfTouchEvent touch;
	sfSensorEvent sensor;
}
alias int sfJoystickAxis;
enum 
{
	sfJoystickX,
	sfJoystickY,
	sfJoystickZ,
	sfJoystickR,
	sfJoystickU,
	sfJoystickV,
	sfJoystickPovX,
	sfJoystickPovY,
}
enum 
{
	sfJoystickCount = 8,
	sfJoystickButtonCount = 32,
	sfJoystickAxisCount = 8,
}
struct sfJoystickIdentification
{
	const(char)* name;
	uint vendorId;
	uint productId;
}
alias int sfKeyCode;
enum 
{
	sfKeyA,
	sfKeyB,
	sfKeyC,
	sfKeyD,
	sfKeyE,
	sfKeyF,
	sfKeyG,
	sfKeyH,
	sfKeyI,
	sfKeyJ,
	sfKeyK,
	sfKeyL,
	sfKeyM,
	sfKeyN,
	sfKeyO,
	sfKeyP,
	sfKeyQ,
	sfKeyR,
	sfKeyS,
	sfKeyT,
	sfKeyU,
	sfKeyV,
	sfKeyW,
	sfKeyX,
	sfKeyY,
	sfKeyZ,
	sfKeyNum0,
	sfKeyNum1,
	sfKeyNum2,
	sfKeyNum3,
	sfKeyNum4,
	sfKeyNum5,
	sfKeyNum6,
	sfKeyNum7,
	sfKeyNum8,
	sfKeyNum9,
	sfKeyEscape,
	sfKeyLControl,
	sfKeyLShift,
	sfKeyLAlt,
	sfKeyLSystem,
	sfKeyRControl,
	sfKeyRShift,
	sfKeyRAlt,
	sfKeyRSystem,
	sfKeyMenu,
	sfKeyLBracket,
	sfKeyRBracket,
	sfKeySemiColon,
	sfKeyComma,
	sfKeyPeriod,
	sfKeyQuote,
	sfKeySlash,
	sfKeyBackSlash,
	sfKeyTilde,
	sfKeyEqual,
	sfKeyDash,
	sfKeySpace,
	sfKeyReturn,
	sfKeyBack,
	sfKeyTab,
	sfKeyPageUp,
	sfKeyPageDown,
	sfKeyEnd,
	sfKeyHome,
	sfKeyInsert,
	sfKeyDelete,
	sfKeyAdd,
	sfKeySubtract,
	sfKeyMultiply,
	sfKeyDivide,
	sfKeyLeft,
	sfKeyRight,
	sfKeyUp,
	sfKeyDown,
	sfKeyNumpad0,
	sfKeyNumpad1,
	sfKeyNumpad2,
	sfKeyNumpad3,
	sfKeyNumpad4,
	sfKeyNumpad5,
	sfKeyNumpad6,
	sfKeyNumpad7,
	sfKeyNumpad8,
	sfKeyNumpad9,
	sfKeyF1,
	sfKeyF2,
	sfKeyF3,
	sfKeyF4,
	sfKeyF5,
	sfKeyF6,
	sfKeyF7,
	sfKeyF8,
	sfKeyF9,
	sfKeyF10,
	sfKeyF11,
	sfKeyF12,
	sfKeyF13,
	sfKeyF14,
	sfKeyF15,
	sfKeyPause,
	sfKeyCount,
}
alias int sfMouseButton;
enum 
{
	sfMouseLeft,
	sfMouseRight,
	sfMouseMiddle,
	sfMouseXButton1,
	sfMouseXButton2,
	sfMouseButtonCount,
}
alias int sfMouseWheel;
enum 
{
	sfMouseVerticalWheel,
	sfMouseHorizontalWheel,
}
alias int sfSensorType;
enum 
{
	sfSensorAccelerometer,
	sfSensorGyroscope,
	sfSensorMagnetometer,
	sfSensorGravity,
	sfSensorUserAcceleration,
	sfSensorOrientation,
	sfSensorCount,
}
struct sfVideoMode
{
	uint width;
	uint height;
	uint bitsPerPixel;
}
alias uint sfWindowStyle;
enum : uint
{
	sfNone = 0,
	sfTitlebar = 1 << 0,
	sfResize = 1 << 1,
	sfClose = 1 << 2,
	sfFullscreen = 1 << 3,
	sfDefaultStyle = sfTitlebar | sfResize | sfClose,
}
alias int sfContextAttribute;
enum 
{
	sfContextDefault = 0,
	sfContextCore = 1 << 0,
	sfContextDebug = 1 << 2,
}
struct sfContextSettings
{
	uint depthBits;
	uint stencilBits;
	uint antialiasingLevel;
	uint majorVersion;
	uint minorVersion;
	sfUint32 attributeFlags;
}
private import derelict.util.system;

static if (Derelict_OS_Windows || Derelict_OS_Mac)
{
	alias void* sfWindowHandle;
}
else
{
	static if (Derelict_OS_Posix)
	{
		private import core.stdc.config;

		alias c_ulong sfWindowHandle;
	}
}
extern (C) nothrow @nogc 
{
	alias sfContext* function() da_sfContext_create;
	alias void function(sfContext*) da_sfContext_destroy;
	alias void function(sfContext*, sfBool) da_sfContext_setActive;
	alias sfBool function(uint) da_sfJoystick_isConnected;
	alias uint function(uint) da_sfJoystick_getButtonCount;
	alias sfBool function(uint, sfJoystickAxis) da_sfJoystick_hasAxis;
	alias sfBool function(uint, uint) da_sfJoystick_isButtonPressed;
	alias float function(uint, sfJoystickAxis) da_sfJoystick_getAxisPosition;
	alias sfJoystickIdentification function(uint) da_sfJoystick_getIdentification;
	alias void function() da_sfJoystick_update;
	alias sfBool function(sfKeyCode) da_sfKeyboard_isKeyPressed;
	alias sfBool function(sfMouseButton) da_sfMouse_isButtonPressed;
	alias sfVector2i function(const(sfWindow)*) da_sfMouse_getPosition;
	alias void function(sfVector2i, const(sfWindow)*) da_sfMouse_setPosition;
	alias sfBool function(sfSensorType) da_sfSensor_isAvailable;
	alias void function(sfSensorType, sfBool) da_sfSensor_setEnabled;
	alias sfVector3f function(sfSensorType) da_sfSensor_getValue;
	alias sfBool function(uint) da_sfTouch_isDown;
	alias sfVector2i function(uint, const(sfWindow)*) da_sfTouch_getPosition;
	alias sfVideoMode function() da_sfVideoMode_getDesktopMode;
	alias const(sfVideoMode)* function(size_t*) da_sfVideoMode_getFullscreenModes;
	alias sfBool function(sfVideoMode) da_sfVideoMode_isValid;
	alias sfWindow* function(sfVideoMode, const(char)*, sfUint32, const(sfContextSettings)*) da_sfWindow_create;
	alias sfWindow* function(sfVideoMode, const(dchar)*, sfUint32, const(sfContextSettings)*) da_sfWindow_createUnicode;
	alias sfWindow* function(sfWindowHandle, const(sfContextSettings)*) da_sfWindow_createFromHandle;
	alias void function(sfWindow*) da_sfWindow_destroy;
	alias void function(sfWindow*) da_sfWindow_close;
	alias sfBool function(const(sfWindow)*) da_sfWindow_isOpen;
	alias sfContextSettings function(const(sfWindow)*) da_sfWindow_getSettings;
	alias sfBool function(sfWindow*, sfEvent*) da_sfWindow_pollEvent;
	alias sfBool function(sfWindow*, sfEvent*) da_sfWindow_waitEvent;
	alias sfVector2i function(const(sfWindow)*) da_sfWindow_getPosition;
	alias void function(sfWindow*, sfVector2i) da_sfWindow_setPosition;
	alias sfVector2u function(const(sfWindow)*) da_sfWindow_getSize;
	alias void function(sfWindow*, sfVector2u) da_sfWindow_setSize;
	alias void function(sfWindow*, const(char)*) da_sfWindow_setTitle;
	alias void function(sfWindow*, uint, uint, const(sfUint8)*) da_sfWindow_setIcon;
	alias void function(sfWindow*, sfBool) da_sfWindow_setVisible;
	alias void function(sfWindow*, sfBool) da_sfWindow_setMouseCursorVisible;
	alias void function(sfWindow*, sfBool) da_sfWindow_setVerticalSyncEnabled;
	alias void function(sfWindow*, sfBool) da_sfWindow_setKeyRepeatEnabled;
	alias sfBool function(sfWindow*, sfBool) da_sfWindow_setActive;
	alias void function(sfWindow*) da_sfWindow_requestFocus;
	alias void function(const(sfWindow)*) da_sfWindow_hasFocus;
	alias void function(sfWindow*) da_sfWindow_display;
	alias void function(sfWindow*, uint) da_sfWindow_setFramerateLimit;
	alias void function(sfWindow*, float) da_sfWindow_setJoystickThreshold;
	alias sfWindowHandle function(const(sfWindow)*) da_sfWindow_getSystemHandle;
}

__gshared 
{
	da_sfContext_create sfContext_create;
	da_sfContext_destroy sfContext_destroy;
	da_sfContext_setActive sfContext_setActive;
	da_sfJoystick_isConnected sfJoystick_isConnected;
	da_sfJoystick_getButtonCount sfJoystick_getButtonCount;
	da_sfJoystick_hasAxis sfJoystick_hasAxis;
	da_sfJoystick_isButtonPressed sfJoystick_isButtonPressed;
	da_sfJoystick_getAxisPosition sfJoystick_getAxisPosition;
	da_sfJoystick_getIdentification sfJoystick_getIdentification;
	da_sfJoystick_update sfJoystick_update;
	da_sfKeyboard_isKeyPressed sfKeyboard_isKeyPressed;
	da_sfMouse_isButtonPressed sfMouse_isButtonPressed;
	da_sfMouse_getPosition sfMouse_getPosition;
	da_sfMouse_setPosition sfMouse_setPosition;
	da_sfSensor_isAvailable sfSensor_isAvailable;
	da_sfSensor_setEnabled sfSensor_setEnabled;
	da_sfSensor_getValue sfSensor_getValue;
	da_sfTouch_isDown sfTouch_isDown;
	da_sfTouch_getPosition sfTouch_getPosition;
	da_sfVideoMode_getDesktopMode sfVideoMode_getDesktopMode;
	da_sfVideoMode_getFullscreenModes sfVideoMode_getFullscreenModes;
	da_sfVideoMode_isValid sfVideoMode_isValid;
	da_sfWindow_create sfWindow_create;
	da_sfWindow_createUnicode sfWindow_createUnicode;
	da_sfWindow_createFromHandle sfWindow_createFromHandle;
	da_sfWindow_destroy sfWindow_destroy;
	da_sfWindow_close sfWindow_close;
	da_sfWindow_isOpen sfWindow_isOpen;
	da_sfWindow_getSettings sfWindow_getSettings;
	da_sfWindow_pollEvent sfWindow_pollEvent;
	da_sfWindow_waitEvent sfWindow_waitEvent;
	da_sfWindow_getPosition sfWindow_getPosition;
	da_sfWindow_setPosition sfWindow_setPosition;
	da_sfWindow_getSize sfWindow_getSize;
	da_sfWindow_setSize sfWindow_setSize;
	da_sfWindow_setTitle sfWindow_setTitle;
	da_sfWindow_setIcon sfWindow_setIcon;
	da_sfWindow_setVisible sfWindow_setVisible;
	da_sfWindow_setMouseCursorVisible sfWindow_setMouseCursorVisible;
	da_sfWindow_setVerticalSyncEnabled sfWindow_setVerticalSyncEnabled;
	da_sfWindow_setKeyRepeatEnabled sfWindow_setKeyRepeatEnabled;
	da_sfWindow_setActive sfWindow_setActive;
	da_sfWindow_requestFocus sfWindow_requestFocus;
	da_sfWindow_hasFocus sfWindow_hasFocus;
	da_sfWindow_display sfWindow_display;
	da_sfWindow_setFramerateLimit sfWindow_setFramerateLimit;
	da_sfWindow_setJoystickThreshold sfWindow_setJoystickThreshold;
	da_sfWindow_getSystemHandle sfWindow_getSystemHandle;
}
class DerelictSFML2WindowLoader : SharedLibLoader
{
	public this();

	protected override void loadSymbols();

}
__gshared DerelictSFML2WindowLoader DerelictSFML2Window;

shared static this();
